/* 
    This file is part of TFox.

    TFox is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TFox is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TFox. If not, see <http://www.gnu.org/licenses/>.
*/

/* This file contains general functions used by extension */

function getpass(username){
    /* Get the password for the defined username*/
    
    if(!username)username = Application.prefs.getValue("extensions.tuentifox.datos.usuario", "");  //If user not specified, use default one
    var password;
    
    if (!username || username == "") {
        password = "";
    } else {
        var hostname = 'chrome://tuenti';
        var formSubmitURL = 'User - Pass';
        var httprealm = null;
        try {
           // Get Login Manager 
           var myLoginManager = Components.classes["@mozilla.org/login-manager;1"]
                                 .getService(Components.interfaces.nsILoginManager);
                  
           // Find users for the given parameters
           var logins = myLoginManager.findLogins({}, hostname, formSubmitURL, httprealm);
              
           // Find user from returned array of nsILoginInfo objects
           for (var i = 0; i < logins.length; i++) {
              if (logins[i].username == username) {
                 password = logins[i].password;
                 break;
              }
           }
        }
        catch(ex) {
           // This will only happen if there is no nsILoginManager component class
           // Firefox 3.0 and above only. Firefox 2.0.x NOT supported 
        }  
    }
    return password;
}
