/* 
    This file is part of TFox.

    TFox is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TFox is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TFox. If not, see <http://www.gnu.org/licenses/>.
*/
var TFox = {
  tuentiStatus: {
    disconected: "0",
    conecting:   "1",
    conected:    "2",
    updates:     "3",
    error:       "4"
  },
  tuentiAction: function(e){
    if(Components.classes["@mozilla.org/privatebrowsing;1"] && Components.classes["@mozilla.org/privatebrowsing;1"].getService(Components.interfaces.nsIPrivateBrowsingService).privateBrowsingEnabled){
      alert("TFox no funciona en modo privado.");
      return;
    }
    
    if(e && e.originalTarget.tagName != "statusbarpanel")return;
	
    if(e && e.button == 1){  //Middle/wheel click
	  if(!TFox.TuentiProxy.isConnected())return;
	  TFox.openURL("http://www.tuenti.com/#m=home");
	  return;
    }else if(e && e.button == 2){ //right button
	  return;
    }

    if (TFox.TuentiProxy.isConnected()) {
	TFox.tuentiWindow();
    } else if(!TFox.TuentiProxy.isConecting()) {
	var user = Application.prefs.getValue('extensions.tuentifox.datos.usuario','');
	if(user == ""){  //no default user
	    TFox.tuentiConnect(null,null,true);   //create one
	}else{
	    TFox.tuentiConnect(user); //Connect to the default user
	}
    }
  },
  openURL: function(url){
	var uri = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(url, null, null);
	Application.activeWindow.open(uri).focus();
  },
  openSidebarURL: function(url,open){
    document.getElementById("viewtfxSidebar").setAttribute("sidebarurl",url);
    if(TFox.isSidebarOpen()){
      var sdb = document.getElementById("sidebar");
      sdb.loadURI(url,sdb.currentURL,null);
    }else if(open)TFox.openSidebar();
  },
  tuentiConnect: function(user,pass,create,logout,notopen){
      Application.storage.get("TuentiReconectFnc",function(){})(user,pass,create,logout,notopen);
  },
  tuentiWindow: function() {
    toggleSidebar('viewtfxSidebar');
  },
  setStatus: function(est){
    document.getElementById("tfxStatusIcon").setAttribute("status",est);
    var strbundle = Application.storage.get("TuentiStrbundle",null);
    document.getElementById("TFox_tooltip_action").value = strbundle.getString(['disconnectedmsg','connecting','connectedmsg','connectedmsg','errormsg'][est]);
  },
  isSidebarOpen: function(){
    return document.getElementById("viewtfxSidebar").getAttribute("checked") == "true";
  },
  closeSidebar: function(){
    if(TFox.isSidebarOpen())
      toggleSidebar("viewtfxSidebar");
  },
  openSidebar: function(){
      toggleSidebar("viewtfxSidebar", true);
  },
  refreshSidebar: function(){
    toggleSidebar("viewtfxSidebar");
    toggleSidebar("viewtfxSidebar");
    TFox.openSidebar();
  },
  getUsers: function(){
      var users=[];
      try {
	 var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager); // Get Login Manager 
	 var logins = myLoginManager.findLogins({}, 'chrome://tuenti', 'User - Pass', null);// Find users for the given parameters
	 for (var i = 0; i < logins.length; i++) {// Find user from returned array of nsILoginInfo objects
	      users.push(logins[i].username);
	 }
      }catch(ex) {}
      return users;
  },
  initEvents: function(){
      var strbundle = Application.storage.get("TuentiStrbundle",null);
      
      var tip = document.getElementById("turntifox_tooltip_action");
      
      var re = TFox.TuentiProxy.addEventListener;
      var events = [
	  re("disconect",function(){
	      TFox.openSidebarURL('chrome://tuenti/content/tuentiUserPass.xul',false);
	      TFox.setLoading(false);//you may get disconected while refreshing
	  }),
	  re("navigateSidebar",function(e){TFox.openSidebarURL(e.url,e.open);}),
	  re("setStatus",function(e){TFox.setStatus(e.status);}),
	  re("lastActChanged",function(e){TFox.setLoading(e.min);}),
	  re("refreshEnd",TFox.onRefreshEnd),
	  re("refreshStart",TFox.onRefreshStart),
	  re("statusChange",TFox.fixStatusIcon),
	  re("notifications",TFox.setTipNots),
	  re("connect",TFox.showInviteNotification)
      ];
      window.addEventListener("close",function(){
	  for each(var k in events)TFox.TuentiProxy.removeEventListener(k);
	  TFox.closeSidebar();
      },true);
      
    
  },
  createMenuItem: function(name,fun,type,check){
      var item = document.createElement("menuitem");
      item.setAttribute("label",name);
      item.addEventListener("command",fun,false);
      if(type)item.setAttribute("type",type);
      if(type == 'radio' && check) item.setAttribute("checked","true");
      return item;
  },
  openhelp:function(){TFox.openURL("http://www.mozilla-hispano.org/labs/tfox/manual/");},
  openpref: function(tab){
    var strbundle = Application.storage.get("TuentiStrbundle",null);
    window.openDialog('chrome://tuenti/content/tuentiPrefs.xul',strbundle.getString("preferences"),'chrome',tab?{tab:tab}:{});
  },
  opentuenti: function(){
    TFox.openURL("http://www.tuenti.com/");
  },
  refresh: function(){
    TFox.TuentiProxy.refresh();
  },
  updateMenu: function(){
    var um =  document.getElementById("TuentiIconMenu");
    um = um.getElementsByTagName("accouts")[0];
    if(!um)return;
    
    while(um.hasChildNodes()){um.removeChild(um.firstChild);}
    
    var users = TFox.getUsers();
    for(var i=0;i<users.length;i++){
      um.appendChild(TFox.createMenuItem(users[i],function(){TFox.changeUser(this);},'radio',users[i] == TFox.TuentiProxy.myemail));
    }
    
    var st = TFox.TuentiProxy.status;
    
    document.getElementById("TuentiMILogin").setAttribute("hidden",st !== 0);
    document.getElementById("TuentiMICancelar").setAttribute("hidden",st !== 1);
    document.getElementById("TuentiMICerrar").setAttribute("hidden",st <= 1);
    
    document.getElementById("TuentiMIActualizar").setAttribute("hidden",st <= 1);
    
  },
  changeUser: function(elm){
      TFox.tuentiConnect(elm.getAttribute("label"));
  },
  setTipNots: function(){    
    var tip = document.getElementById("TFox_updates");
    while(tip.hasChildNodes()){tip.removeChild(tip.firstChild);}
    for (var i = 0; i < TFox.TuentiProxy.updates.length; i++) {
	    var label=document.createElement("label");
	    label.appendChild(document.createTextNode(TFox.TuentiProxy.updates[i].txt))
	    tip.appendChild(label);
    }
  },
  openrec: function(){
    window.openDialog("chrome://tuenti/content/tuentiInvite.xul","invite",'chrome');
  },
  showInviteNotification: function(){
    var strbundle = Application.storage.get("TuentiStrbundle",null);
    if(Application.prefs.getValue("extensions.tuentifox.datos.nsids","").length > 2 ||
       !gBrowser || !gBrowser.getNotificationBox || !strbundle ||
       !TFox.isNotFirstInit)return;
    var nb = gBrowser.getNotificationBox();
    if(!nb)return;
    nb.appendNotification(
	      strbundle.getString("invite"),
	      "tfx-invite-notification",
	      "http://www.tuenti.com/favicon.ico",
	      nb.PRIORITY_INFO_MEDIUM,
	      [{
		label: strbundle.getString("inviteYes"),
		callback: function(notification){
		  notification.close();
		  TFox.openrec();
		},
		accessKey: null
	      },{
		label: strbundle.getString("inviteNotNow"),
		callback: function(notification){
		  notification.close();
		},
		accessKey: null
	      },{
		label: strbundle.getString("inviteNever"),
		callback: function(notification){
		  notification.close();
		  Application.prefs.setValue("extensions.tuentifox.datos.nsids",",10");
		},
		accessKey: null
	      }]
    );
  },
  onRefreshStart: function(){
    TFox.setLoading(true);
  },
  onRefreshEnd: function(){
    TFox.setLoading(0);
  },
  setLoading: function(bool){
    var loadbox = document.getElementById("TFox_loading_icon");
    if(loadbox){
        var lbl = document.getElementById("TFox_last_update");
	if(!lbl)return;
        document.getElementById("tuentiLoadingOverlay").setAttribute("collapsed",!(bool===true));
	loadbox.setAttribute("selectedIndex",bool===true?0:1);
	if(typeof bool == typeof 1){
	  var strbundle = Application.storage.get("TuentiStrbundle",null);
	  lbl.value = strbundle.getFormattedString("lastupdate",[bool]);
	}
    }else{
	var strbundle = Application.storage.get("TuentiStrbundle",null);	   
	var sb = document.getElementById("sidebar-box");
	if(!sb){ //El sidebar no esta abierto
	  return;
	}
	var deck = document.createElement("deck");
	var hbox = document.createElement("hbox");
	var img = document.createElement("image");
	var label2 = document.createElement("label");
	label2.id="TFox_last_update";
	
	img.setAttribute("src","chrome://global/skin/icons/loading_16.png");
	var label= document.createElement("label");
	label.setAttribute("value",strbundle.getString("loading"));
	
	deck.id="TFox_loading_icon";
	hbox.appendChild(img);
	hbox.appendChild(label)
	
	deck.appendChild(hbox);
	deck.appendChild(label2);
	
	var header = sb.firstChild;
	var lbl = header.firstChild;
	
	header.insertBefore(deck, lbl.nextSibling);
	TFox.setLoading(bool);
    }
  },
  fixStatusIcon: function(){
    switch(TFox.TuentiProxy.status){
	case 0: //desconectado
	  TFox.setStatus(TFox.tuentiStatus.disconected);
	  break;
	case 1: //conectando
	  TFox.setStatus(TFox.tuentiStatus.conecting);
	  break;
	case 2://conectado
	  var upd = false;
	case 3://actualizando
	  if(TFox.TuentiProxy.updates.length>0)
	    TFox.setStatus(TFox.tuentiStatus.updates);
	  else
	    TFox.setStatus(TFox.tuentiStatus.conected);
	    
	  if(upd === false)TFox.setLoading(false);
	  else TFox.setLoading(true);
	  break;
    }
  },
  watchForPrivateMode: function(){
    var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    var obs = {observe:function(aSubject, aTopic, aData) {
      try{
	if (aTopic == "private-browsing") {
	  if (aData == "exit"){
	      TFox.fixStatusIcon();
	      TFox.initEvents();
	  }else{
	      TFox.fixStatusIcon();
	  }
	} else if (aTopic == "quit-application") {
	  os.removeObserver(obs, "quit-application");
	  os.removeObserver(obs, "private-browsing");
	}
      }catch(e){dump("Error 2: " + e + "\n");}
    }};
    os.addObserver(obs, "private-browsing", false);
    os.addObserver(obs, "quit-application", false);
  },
  main: function(){
    if(Components.classes["@mozilla.org/privatebrowsing;1"] && Components.classes["@mozilla.org/privatebrowsing;1"].getService(Components.interfaces.nsIPrivateBrowsingService).privateBrowsingEnabled){
      TFox.TuentiProxy.disconnect(true);
      TFox.fixStatusIcon();
      TFox.closeSidebar();
      TFox.watchForPrivateMode();
      return;
    }
    TFox.watchForPrivateMode();
    TFox.closeSidebar();
    TFox.initGlobal(TFox.main);
    TFox.fixStatusIcon();
    TFox.initEvents();
	
	//Since TFoxOverlay may not be loaded if the "Modificaciones en la web" preference is disabled, we have to check for firstRun / upgrade here	
	var extension = Application.extensions.get("tuentifox@mozilla-hispano.org");
	
	if(extension.firstRun && !Application.prefs.getValue("extensions.tuentifox.version",false)){
		window['setTimeout'](function(){
			Application.activeWindow.open(Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI("chrome://tuenti/content/firstrun.xhtml", null, null)).focus();
		},200);
		Application.prefs.setValue("extensions.tuentifox.version",extension.version);
	}else if(Application.prefs.getValue("extensions.tuentifox.version","0.0") !== extension.version){ //Si no acabamos de instalar la extension y la version de la preferencia es distinta que la version actual
		Application.prefs.setValue("extensions.tuentifox.version",extension.version);
		window['setTimeout'](function(){
			Application.activeWindow.open(Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI("chrome://tuenti/content/update.xhtml", null, null)).focus();
		},200);
	}else{
	        TFox.isNotFirstInit = true;
	}
  }
};

Components.utils.import("resource://tuenti/tuentiAPI.jsm",TFox);
Components.utils.import("resource://tuenti/TFox.jsm",TFox);
//Components.utils.import("resource://tuenti/tuentiChat.jsm",TFox);

/*(function(tf){
  
  var chat_enabled = true;
  
  var Chat = tf.chat;
  var TuentiProxy = tf.TuentiProxy;
  
  var chat_popup = document.getElementById('TFox_chat_popup');
  
  function toogleChat(){
    if(chat_popup.state == "open"){
      closeChat
    }else{
      openChat();
    }
  }
  
  function closeChat(){
    chat_popup.setAttribute("hidden",false);
    chat_popup.hidePopup();
  }
  
  function openChat(){
    chat_popup.setAttribute("hidden",false);
    //chat_popup.openPopup(document.getElementById('status-bar'), 'before_end', -26, -10, false, true);
  }
  
  
  
  TuentiProxy.addEventListener("connect",function(){	//FIXME: Esto se repetira en todas las ventanas, y no deberia
    if(TuentiProxy.chatData && chat_enabled){
      //Chat.login(TuentiProxy.chatData);
    }
  });
  
  Chat.addEventListener("JSJaConconnect",function(){
    openChat();
  });
  
  Chat.addEventListener("UIRequestOpenConversation",function(aData){
    
  });
  
  
  
  
  
})(TFox)*/

window.addEventListener("load", TFox.main, true);



