﻿/* 
    This file is part of TFox.

    TFox is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TFox is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TFox. If not, see <http://www.gnu.org/licenses/>.
*/
Components.utils.import("resource://tuenti/tuentiAPI.jsm");

var thumbs = [];
thumbsDisplayed = 0;

/*
 *  UI CODE
 *
 *
 */
function createFileThumb(file){
	var vbox = document.createElement("stack");
	var img = document.createElement("image");
	var toolbar = document.createElement("hbox");
	var toolbarc = document.createElement("vbox");

	//toolbar.appendChild(createButton("","","toolButton"));
	var spacer = document.createElement("spacer");
	spacer.setAttribute("flex","1");
	toolbarc.appendChild(spacer);
	toolbar.appendChild(createButton("removeThumb(this.parentNode.parentNode.parentNode.getAttribute('indexA'));","deleteBtn"));
	toolbarc.appendChild(toolbar);
	
	//rotate buttoms (not implemented yet)
	//toolbar.appendChild(createButton("rotate(thumbs[this.parentNode.parentNode.getAttribute('indexA')]['file']['target'],0,true);","editBtn"));
	//toolbar.appendChild(createButton("rotate(thumbs[this.parentNode.parentNode.getAttribute('indexA')]['file']['target'],1,true);","editBtn"));
	
	
	img.setAttribute("class","thumbImg");
	vbox.setAttribute("class","thumb");
	
	img.setAttribute("src",getURLFromFile(file));
	
	vbox.appendChild(img);
	vbox.appendChild(toolbarc);
	
	return vbox;
}

function createPartialFileUpload(img){
	var hbox= document.createElement("bbox");
	var imag = document.createElement("image");
	var name = document.createElement("description");
	var staimg = document.createElement("image");
	staimg.setAttribute("class","status");
	
	hbox.setAttribute("onclick","this.setAttribute('sel','true');tagImage(this.getAttribute('indexA'));");
	
	imag.setAttribute("src",getURLFromFile(img.file));
	var names = img.oldname;
	names = names.length>20?names.substring(0,19)+"…":names;
	name.appendChild(document.createTextNode(names));
	name.setAttribute("flex","1");
	
	imag.setAttribute("class","pdImg");
	hbox.setAttribute("class","pdCon");
	
	hbox.appendChild(imag);
	hbox.appendChild(name);
	hbox.appendChild(staimg);
	
	return hbox;
}
function checkIntro(e,act){
	if(e.keyCode == 13){
		act();
	}
}

function changeStatus(elm,run,sta){
	if(!elm)return;
	
	elm.setAttribute("tooltiptext",sta);
	
	if(run == 0){
		elm.setAttribute("class","pdCon load");
	}else if(run ==1){
		elm.setAttribute("class","pdCon ok");
	}if(run ==2){
		elm.removeAttribute("ok");
		elm.setAttribute("class","pdCon fail");
	}
}

/*
 *FUNCTIONS
 */

function getURLFromFile(aFile) {
    var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
    return fileHandler.getURLSpecFromFile(aFile);
}


function showFilePicker()
{
	var strbundle = Application.storage.get("TuentiStrbundle",null);
	var nsIFilePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
	nsIFilePicker.init(window, strbundle.getString("uploadtitle"), Components.interfaces.nsIFilePicker.modeOpenMultiple);
	//nsIFilePicker.appendFilters(0x08);
	nsIFilePicker.appendFilter("Imagenes","*.jpg; *.gif; *.png; *.jpeg");
	
	if (nsIFilePicker.show() == Components.interfaces.nsIFilePicker.returnOK)
	{
		//nsIFilePicker.files.getNext();
		//TuentiProxy._uploadFiles([nsIFilePicker.file],1);
		
		var files = nsIFilePicker.files;
		while(files.hasMoreElements()){
			var file = files.getNext().QueryInterface(Components.interfaces.nsIFile);
			var mime = getMIMEType(file);
			if(mime && mime.indexOf("image")>=0){
				apendFile(file);
			}
		}
	}
}


function uploadURL(url){
	var strbundle = Application.storage.get("TuentiStrbundle",null);
	if(!url){
		var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var input = {value: ""};
		prompts.prompt(window, strbundle.getString("writeurltitle"), strbundle.getString("writeurl"), input, null, {});
		url = input.value;
	}
	
	try{
		var obj_URI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(url, null, null);
	}catch(e){
		alert(strbundle.getString("urlnotimage"));
		return;
	}
	
	scaleImg(obj_URI.spec,function(file){
		apendFileNS(file);
	});
}

function paste(){
	var nsIClipboard = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
	var nsITransferable_trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
	nsITransferable_trans.addDataFlavor("image/jpg");
	nsIClipboard.getData(nsITransferable_trans, Components.interfaces.nsIClipboard.kGlobalClipboard);
	var out = {}, outLen = {};
	try
	{
		nsITransferable_trans.getTransferData("image/jpg", out, outLen);
	}
	catch(e)
	{
		return;
	}
	var iStream = out.value;
	iStream.QueryInterface(Components.interfaces.nsIInputStream);
	var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
	file.append("TFox_clipboard_" + Math.round(Math.random()*1000000) + ".jpg");
	file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	foStream.init(file, 0x02 | 0x08 | 0x20, 0666, 0);
	var size = iStream.available();
	var binStream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
	binStream.setInputStream(iStream);
	var boutStream = Components.classes["@mozilla.org/binaryoutputstream;1"].createInstance(Components.interfaces.nsIBinaryOutputStream);
	boutStream.setOutputStream(foStream);
	boutStream.writeByteArray(binStream.readByteArray(size), size);
	boutStream.close();
	foStream.close();
	binStream.close();
	iStream.close();
	file.QueryInterface(Components.interfaces.nsILocalFile);
	file.initWithFile(file);
	apendFile(file,true);
}

function apendFile(file,del){
		var strbundle = Application.storage.get("TuentiStrbundle",null);
		var oldurl = getURLFromFile(file);
		var oldname = file.leafName;
		if(alreadyIs(file)){
			if(!confirm(strbundle.getFormattedString("theimagealreadyis",[oldname])))
				return;
		}
		scaleImg(oldurl,function(newfile){
			var thumb = createFileThumb(newfile);
			appendThump(thumb);
			thumbs[thumbs.length] = {'elm':thumb,oldurl:oldurl,oldname:oldname,oldfile:file,'file':newfile,'uploaded':false,'uploading':false,'delete':del?true:false};
			setActive();
		});
}
function apendFileNS(file,del){
		var strbundle = Application.storage.get("TuentiStrbundle",null);
		var oldurl = getURLFromFile(file);
		var oldname = file.leafName;
		if(alreadyIs(file)){
			if(!confirm(strbundle.getFormattedString("theimagealreadyis",[oldname])))
				return;
		}
		var thumb = createFileThumb(file);
		appendThump(thumb);
		thumbs[thumbs.length] = {'elm':thumb,oldurl:oldurl,oldname:oldname,oldfile:file,'file':file,'uploaded':false,'uploading':false,'delete':del?true:false};
		setActive();
}

function setActive(){
	document.getElementById("BtnUpload").setAttribute("active",(thumbs.length>0)?"true":"false");
}

function alreadyIs(file){
	var url = getURLFromFile(file);
	for(var i=0;i<thumbs.length;i++){
		if(thumbs[i].oldurl == url)
			return true;
	}
	return false;
}

function createButton(cmd,clas){
	var toolD = document.createElement("toolbarbutton");
	
	toolD.setAttribute("class",clas);
	toolD.setAttribute("oncommand",cmd)

	return toolD;
}

const cols = 6;

function appendThump(thumb){
	var tc = document.getElementById("thumbsContainer");
	
	thumb.setAttribute("indexA",thumbsDisplayed);
	
	var elmsInLastRow = thumbsDisplayed % cols;
	if(elmsInLastRow == 0){
		var row = document.createElement("row");
		tc.appendChild(row);
	}else{
		var row = tc.childNodes[tc.childNodes.length-1];
	}
	row.appendChild(thumb);
	thumbsDisplayed++;
}

function updateThumbs(){
	var tc = document.getElementById("thumbsContainer");
	while(tc.hasChildNodes()){
		tc.removeChild(tc.firstChild);
	}
	thumbsDisplayed = 0;
	for(var i=0;i<thumbs.length;i++){
		appendThump(thumbs[i]['elm']);
	}
}
function removeThumb(index){
	thumbs.splice(index,1);
	updateThumbs();
	setActive();
}

function uploadPhotos(){
	if(thumbs.length==0)return;
	document.getElementById("deckP").setAttribute("selectedIndex","1");
	var up = document.getElementById("uploadProgress");
	up.value = 0;
	var pu = document.getElementById("partialUploads");
	
	for(var i=0;i<thumbs.length;i++){
		thumbs[i]['status'] = 0;
		thumbs[i]['pu'] = createPartialFileUpload(thumbs[i]);
		thumbs[i]['pu'].setAttribute("indexA",i);
		pu.appendChild(thumbs[i]['pu']);
	}
	startUpload()
	
}
const MAX_PARALEL_UPLOADS = 5;
var uploads = 0;
function startUpload(){
	var strbundle = Application.storage.get("TuentiStrbundle",null);
	var listener={
		onUploadComplete:function(id){
			//*ifdebug*/dump("Complete. id:" + id +"\n");
			changeStatus(thumbs[id].pu,0,strbundle.getString("checking"));
		},
		onUploadError:function(id, errcde,rid){
			//*ifdebug*/dump("Error. id:" + id +" error: "+errcde+"\n");
			thumbs[id].uploaded = true;
			changeStatus(thumbs[id].pu,2,"Error " + errcde);
			uploads--;
			uploadNexts();
		},
		onUploadEnd:function(id,id1){
			//*ifdebug*/dump("Completed. id: "+id+" id1:" + id1 +"\n");
			var thumb = thumbs[id];
			thumb.uploaded = true;
			thumb.id1 = id1;
			cloudTag(false,thumb);
			uploads--;
			changeStatus(thumb.pu,1,strbundle.getString("ended"));
			thumb.pu.setAttribute("tag","true");
			uploadNexts();
		}
	}
	TuentiProxy.startUploadSession(listener);
	
	uploadNexts();
}

function getThumbById1(id1){
	for(var k in thumbs){
		if(thumbs[k].id1==id1){return thumbs[k];}
	}
	return null;
}
function uploadNexts(){
	updateProgress();
	while(uploads < MAX_PARALEL_UPLOADS){
		if(!uploadNext()){
			if(isComplete()){
				TuentiProxy.endUploadSession(false); //No more images. End session
			}
			return;
		}
	}
}
function uploadNext(){
	var strbundle = Application.storage.get("TuentiStrbundle",null);
	for(var i=0;i<thumbs.length;i++){
		if(!thumbs[i].uploading){
			TuentiProxy.startUploadFile(thumbs[i]['file'],i);
			thumbs[i].uploading = true;
			uploads++;
			changeStatus(thumbs[i].pu,0,strbundle.getString("uploading"));
			return true;
		}
	}
	return false; //no more images to upload
}

function isComplete(){
	for(var i=0;i<thumbs.length;i++){
		if(!thumbs[i].uploaded){
			//*ifdebug*/dump("no completado\n");
			return false;
		}
	}
	//*ifdebug*/dump("completado\n");
	return true;
}
function updateProgress(){
	var comp = 0;
	for(var i=0;i<thumbs.length;i++){
		comp += thumbs[i].uploaded?1:0;
	}
	var up = document.getElementById("uploadProgress");
	up.value= (comp*100)/thumbs.length;
}


var tagData={
	actualTag: null,
	actualTagx: -1,
	actualTagy: -1,
	tags: [],
	tagImg: null
	
};


function tagImage(imge){
	cancalTag();
	document.getElementById("tagImage").setAttribute("src",getURLFromFile(thumbs[imge].file));
	document.getElementById("editpane").setAttribute("collapsed","false");
	tagData.tagImg = imge;
	if(!thumbs[imge].tags)return;
	var tags = thumbs[imge].tags;
	for each(var k in tags){
		appendTag({layerX:k.x,layerY:k.y},true);
		addTag(k.name);
	}
	if(!thumbs[imge].title)return;
	document.getElementById("tagtitle").value = thumbs[imge].title;
}
function cancalTag(){
	document.getElementById("editpane").setAttribute("collapsed","true");
	document.getElementById("tagtitle").value = '';
	var tc = document.getElementById("tagsContainer");
	var cn = tc.childNodes;
	for(var i=1;i<cn.length;i++){
		tc.removeChild(cn[i]);
	}
	
	if(tagData.tagImg && thumbs[tagData.tagImg])thumbs[tagData.tagImg ]['pu'].removeAttribute("sel");
	
	tagData={
		actualTag: null,
		actualTagx: -1,
		actualTagy: -1,
		tags: [],
		tagImg: null
	};
	
	var tcc = document.getElementById("tagsc");
	while(tcc.hasChildNodes())tcc.removeChild(tcc.firstChild);
	
	
}
function appendTag(e,force){
	if(force){
		var tagx = e.layerX;
		var tagy = e.layerY;
	}else{
		var img = document.getElementById("tagImage");
		var tagx = Math.max(25,e.layerX);
		var tagy = Math.max(25,e.layerY);
		var tagx = Math.min(img.boxObject.width-25,tagx);
		var tagy = Math.min(img.boxObject.height-25,tagy);
	}
	tagData.actualTagx = tagx;
	tagData.actualTagy = tagy;
	
	setEditTagEnable(true);
	
	if(tagData.actualTag){
		var tt = tagData.actualTag;
		tt.ox = tagx;
		tt.oy = tagy;
	}else{
		var tc = document.getElementById("tagsContainer");
		var tt = document.createElement("tuentitag");
		tc.appendChild(tt);
		tagData.actualTag = tt;
		tt.ox = tagx;
		tt.oy = tagy;
	}
}
function setEditTagEnable(bool){
	var tn = document.getElementById("tagname");
	tn.disabled = !bool;
	tn.value="";
	tn.focus();
	document.getElementById("updatebutton").disabled = !bool;
}
function addTag(oname){
	var name = oname || document.getElementById("tagname").value;
	if(!name)return;
	name = name.replace(/^\s*/g,"").replace(/\s*$/g,"");
	var friend = TuentiProxy.getFriendByName(name);
	if(!friend){
		alert("No es tu amigo");
		return;
	}
	for (var k in tagData.tags){
		if(tagData.tags[k].name == name){
			alert("Ya esta en la lista");
			setEditTagEnable(true);
			return;
		}
	}
	
	setEditTagEnable(false);
	tagData.tags.push({
		name: name,
		id: friend.id,
		x: tagData.actualTagx,
		y: tagData.actualTagy,
		tage: tagData.actualTag
	});
	tagData.actualTag.setAttribute("hidden","true");
	var tage = tagData.actualTag;
	tagData.actualTag = null;
	
	var tagc = document.getElementById("tagsc");
	var tag = document.createElement("bbox");
	var lbl = document.createElement("label");
	lbl.setAttribute("value",(name.length>22)?name.substring(0,22)+"…":name);
	
	var toolD = document.createElement("toolbarbutton");
	toolD.setAttribute("class","deleteBtn");
	toolD.addEventListener("click",function(){
		for (var k in tagData.tags){
			if(tagData.tags[k].name == name){
				delete tagData.tags[k];
				tag.parentNode.removeChild(tag);
				tage.parentNode.removeChild(tage)
				return;
			}
		}
	},true);
	
	tag.appendChild(toolD);
	tag.appendChild(lbl);
	
	tag.addEventListener("mouseover",function(){
		tage.setAttribute("hidden","false");
	},true);
	tag.addEventListener("mouseout",function(){
		tage.setAttribute("hidden","true");
	},true);
	tagc.appendChild(tag);
	
}
function saveTags(){
	var t = thumbs[tagData.tagImg];
	var img = document.getElementById("tagImage");
	var w = img.boxObject.width;
	var h = img.boxObject.height;
	var tit = document.getElementById("tagtitle").value;
	tit = (tit=="")?document.getElementById("tagtitle").getAttribute("emptytext"):tit;
	var ta = [];
	for each(var k in tagData.tags){
		ta.push({id:k.id,
			name:k.name,
			px:round((k.x/w)*100),
			py:round((k.y/h)*100),
			x:k.x,
			y:k.y
		});
	}
	
	thumbs[tagData.tagImg].tags = ta;
	thumbs[tagData.tagImg].title = tit;
	
	if(t.uploaded){
		TuentiProxy.tagImage(t.id1,ta,tit)
	}
	
	cancalTag();
	
}
function cloudTag(n,th){
	var t = n?thumbs[n]:th;
	if(!t || !t.tags || !t.title)return;
	TuentiProxy.tagImage(t.id1,t.tags,t.title);
}

function round(n){
	return Math.round(n*10000000000000)/10000000000000
}
function deleteTemp(){
	for each(var k in thumbs){
		if(k['delete']){
			deletef(k['file']);
		}
	}
	deleteTmpFiles();
}

dropObserver =
{
	canHandleMultipleItems: true,
	onDragOver: function(){
		document.getElementById("thumbsContainer").setAttribute("dragg","true");
	},
	onDragExit: function(){
		document.getElementById("thumbsContainer").removeAttribute("dragg");
	},
	onDrop:function(event, dropData)
	{
		document.getElementById("thumbsContainer").removeAttribute("dragg");
		dropData.dataList.forEach(
			function(value)
			{
				if(value.first.data == "[xpconnect wrapped nsIFile]"){
					var file = value.first.data.QueryInterface(Components.interfaces.nsIFile);
					var mime = getMIMEType(file);
					if(mime && mime.indexOf("image")>=0){
						apendFile(file);
					}
				}else{
					var url = value.first.data;
					var end = url.indexOf("\n");
					if(end>0)url = url.substring(0,end);
					uploadURL(url);
				}
		});
	},
	getSupportedFlavours:function()
	{
		var flavors = new FlavourSet();
		flavors.appendFlavour("application/x-moz-file","nsIFile");
		flavors.appendFlavour("text/x-moz-url");
		return flavors;
	}
}

function getMIMEType(nsiFile){
	try{
		var mimeService = Components.classes["@mozilla.org/mime;1"].createInstance(Components.interfaces.nsIMIMEService);  
		return mimeService.getTypeFromFile(nsiFile);
	}catch(e){
		return false;
	}
}
function getMIMETypeurl(nsiUrl){
	try{
		var mimeService = Components.classes["@mozilla.org/mime;1"].createInstance(Components.interfaces.nsIMIMEService);  
		return mimeService.getTypeFromURI(nsiUrl);
	}catch(e){
		return false;
	}
}


function unload(){
	TuentiProxy.endUploadSession();
	deleteTemp();
}
window.addEventListener("close",unload,true);


var filesToDelete = [];
const IMAGE_WIDTH = 600;
const IMAGE_CALIDAD = 90;
function scaleImg(url,f){
	var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
	file.append("TFox_small_" + url.replace(/[^a-z0-9_]/gi,"_") + Math.round(Math.random()*10000) + ".jpg");
	filesToDelete.push(file);
	
	var ofile = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
	ofile.append("TFox_original_" + url.replace(/[^a-z0-9_]/gi,"_") + Math.round(Math.random()*10000) + ".jpg");
	filesToDelete.push(ofile);
	
	
	downloadURL(url,ofile,function(){
		var img = new Image();
		img.onload = function(){
			var canvas = document.createElementNS("http://www.w3.org/1999/xhtml","html:canvas");
			var ctx = canvas.getContext("2d");
			var width = canvas.width = Math.min(img.width,IMAGE_WIDTH);
			var height = canvas.height = img.height*width/img.width;
			ctx.fillStyle = "#FFF";//Fondo banco en imagenes con transparencia
			ctx.fillRect (0,0,width,height);
			ctx.drawImage(img,0,0,width,height);
			var durl = canvas.toDataURL("image/jpeg", "quality="+IMAGE_CALIDAD);
			downloadURL(durl,file,function(){
				f(file.fileSize<ofile.fileSize?file:ofile); //Usamos la mas pequeña
			});
		}
		img.src = getURLFromFile(ofile);
	});
	
	

}

function downloadURL(url, file, callback){
	var io = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);  
	var source = io.newURI(url, "UTF8", null);
	var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);  
	persist.persistFlags = Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_REPLACE_EXISTING_FILES;  
	persist.persistFlags |= Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;  
	persist.progressListener = {
		onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {},
		onStateChange: function(aWebProgress, aRequest, aStatus, aMessage) {
			if((aStatus & 0x000000000010) == 0x10){
				if(file.exists()){
					callback(file);
				}else{
					alert("Error guardando la imagen");
				}
			}
		},
		onStatusChange: function(){}
	}
	
	persist.saveURI(source, null, null, null, null, file);
}


function deleteTmpFiles(){
	for each(var k in filesToDelete){
		try{
			deletef(k);
		}catch(e){}
	}
	filesToDelete = [];
}
function deletef(file){
		try{
			file.remove(false);
		}catch(e){
			//alert(e);
		}
}
