/* 
    This file is part of TFox.

    TFox is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TFox is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TFox. If not, see <http://www.gnu.org/licenses/>.
*/

// Main overlay
var TFoxOverlay;

//FIXME Disable Tuenti integration till js issue is fixed to let site load correctly
if(Components.classes["@mozilla.org/preferences-service;1"]
   .getService(Components.interfaces.nsIPrefBranch)
   .getBoolPref("extensions.tuentifox.datos.web.enable") && false){

  //*ifdebug*/function log(str){dump("[tfxoverlay] " + str + "\n")}
  TFoxOverlay = {
  /**
   *Preferences system
   */
   enableTuentiMenuItems : true,
   enableSelectAll       : true,
   enableClassicTags     : true,
   enableTuentiImageTip  : true,
   enableTuentiDownload  : true,
   tuentiImageTipWidth   : 600,
   tuentiRealImageWidth  : 350,
  
   tuentiPrefObserver :{
    register: function(){
      var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);
      this._branch = prefService.getBranch("extensions.tuentifox.datos.web.");
      this._branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
      this._branch.addObserver("", this, false);
    },
    unregister: function(){
      if(!this._branch) return;
      this._branch.removeObserver("", this);
    },
    observe: function(aSubject, aTopic, aData){
      if(aTopic != "nsPref:changed") return;
  
      var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefBranch);
      var gbp = prefs.getBoolPref;
      switch (aData) {
        case "enabledownloadlink":
          
          TFoxOverlay.enableTuentiDownload =
                gbp("extensions.tuentifox.datos.web.enabledownloadlink");
          break;
        case "enableclassictags":
          TFoxOverlay.enableClassicTags =
                gbp("extensions.tuentifox.datos.web.enableclassictags");
          break;
        case "enableselectall":
          TFoxOverlay.enableSelectAll =
                gbp("extensions.tuentifox.datos.web.enableselectall");
          break;
        case "enableimagetip":
          TFoxOverlay.enableTuentiImageTip =
                gbp("extensions.tuentifox.datos.web.enableimagetip");
          break;
        case "imagetipwidth":
          var TipWidth =
               prefs.getIntPref("extensions.tuentifox.datos.web.imagetipwidth");
          TFoxOverlay.tuentiRealImageWidth = TipWidth==500?600:TipWidth;
          TFoxOverlay.tuentiImageTipWidth  = (TipWidth==200)?200:600;
        case "enablecontextmenu":
          TFoxOverlay.enableTuentiMenuItems =
                gbp("extensions.tuentifox.datos.web.enablecontextmenu");
          break;
      }
    }
   },
  
   main: function(){
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefBranch);
    var gbp = prefs.getBoolPref;
    TFoxOverlay.enableTuentiDownload   =
          gbp("extensions.tuentifox.datos.web.enabledownloadlink");
    TFoxOverlay.enableTuentiImageTip   =
          gbp("extensions.tuentifox.datos.web.enableimagetip");
    TFoxOverlay.enableTuentiMenuItems  =
          gbp("extensions.tuentifox.datos.web.enablecontextmenu");
    TFoxOverlay.enableSelectAll        =
          gbp("extensions.tuentifox.datos.web.enableselectall");
    TFoxOverlay.enableClassicTags      =
          gbp("extensions.tuentifox.datos.web.enableclassictags");
    var TipWidth                            =
          prefs.getIntPref("extensions.tuentifox.datos.web.imagetipwidth");
    TFoxOverlay.tuentiRealImageWidth   = TipWidth==500?600:TipWidth;
    TFoxOverlay.tuentiImageTipWidth    = (TipWidth==200)?200:600;
    TFoxOverlay.tuentiPrefObserver.register();
    window.document.addEventListener("DOMContentLoaded",
                                     TFoxOverlay.onContentLoaded, true);
    document.getElementById("contentAreaContextMenu")
            .addEventListener("popupshowing",
                              TFoxOverlay.onPopupShowing, false);
   },
   onTuentiChanged: function(e){
      //*ifdebug*/log("changed");
      var win = e.originalTarget.defaultView.top;
      TFoxOverlay.injectInWindow(win);
   },
    onContentLoaded: function(e){
      var doc = e.originalTarget;
      var loc = doc.location;
      
      
      if (loc.href.indexOf(".tuenti.com") > 0
          && /^http:\/\/[a-z0-9]*.tuenti.com\//.test(loc.href)){
        if(/^http:\/\/[^\.]+\.tuenti\.(com|net)\/request_engine\/.*\.html$/.test(loc.href)){ // Es un iframe "cargador"
          //*ifdebug*/log("añadido iframe por tuenti...");
          var win = doc.defaultView;
          var obj = win.wrappedJSObject || win;
          var script = doc.createElement("script");
          script.setAttribute("type","text/javascript");
          script.setAttribute("src","chrome://tuentiaccessible/content/iframeoverlay.js");
          doc.getElementsByTagName("head")[0].appendChild(script);
          doc.addEventListener("TFox-tuenti-updated",TFoxOverlay.onTuentiChanged,false);
        }
        
        var win = doc.defaultView.top;
        var doc = win.document;
        
        TFoxOverlay.mod.injectTheme(doc);
        
        if(!doc.getElementById("TFox-have-jquery")){
          var sc = doc.createElement("script");
          sc.setAttribute("type","text/javascript");
          sc.setAttribute("src","chrome://tuentiaccessible/content/jquery.js");
          doc.getElementsByTagName("head")[0].appendChild(sc);
          doc.addEventListener("TFox-tuenti-updated",TFoxOverlay.onTuentiChanged,false);
        }
      }
    },
    injectInWindow: function(win){
      win = win.top;
      var unsafeWin = win.wrappedJSObject?win.wrappedJSObject:win;
      var $ = unsafeWin.jQuery;
      var doc = win.document;
      
      if(!$ || !doc || !doc.body)return;
      
      //*ifdebug*/log("+++++++++++++++++++++++++++++");
      if(TFoxOverlay.enableSelectAll)
        TFoxOverlay.mod.injectSelectAll($,doc,win);
      if(TFoxOverlay.enableTuentiImageTip)
        TFoxOverlay.mod
          .injectImageTips($,TFoxOverlay.tuentiImageTipWidth,
                           TFoxOverlay.tuentiRealImageWidth);
      if(TFoxOverlay.enableClassicTags)
        TFoxOverlay.mod.injectClassicTags($,window);
      if(TFoxOverlay.enableTuentiDownload)
        TFoxOverlay.mod.injectImageDownload($,doc,window);
        //*ifdebug*/log("------------------------------");
      //if(/*TODO*/true)TFoxOverlay.mod.makeColor($,doc,win);
      if(/*TODO*/true)TFoxOverlay.mod.injectTheme(doc);
    },
    uploadImage: function(){
      TFoxOverlay.uploadURL(gContextMenu.imageURL || gContextMenu.mediaURL);
    },
    uploadBGImage: function(){
      TFoxOverlay.uploadURL(gContextMenu.bgImageURL);
    },
    uploadURL: function(url){
      var win = TFoxOverlay.getUploadWindow();
      if(win.uploadURL){  //if the function exist
        win.uploadURL(url);
        win.getAttention();
      }else{          //else the window isn't loaded yet, wait 100ms and retry
        window['setTimeout'](function(){TFoxOverlay.uploadURL(url);},100);
      }
    },
    getUploadWindow: function(){
      var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                         .getService(Components.interfaces.nsIWindowMediator);
      var enumerator = wm.getEnumerator("tuentiUploadWindow");
      var win = enumerator.getNext();
      if(win)return win;  //The upload window is open.
      
      return window.openDialog("chrome://tuenti/content/tuentiImages.xul","Upload",'resizable=no');
    },
    onPopupShowing: function(){
      if(TFoxOverlay.enableTuentiMenuItems){
        document.getElementById("tuentiUploadImage").hidden = !gContextMenu.onImage;
        document.getElementById("tuentiUploadBgImage").hidden = !gContextMenu.hasBGImage;
      }else{
        document.getElementById("tuentiUploadImage").hidden = true;
        document.getElementById("tuentiUploadBgImage").hidden = true;
      }
    },
    mod: {}
  };
  
  Components.utils.import("resource://tuenti/tuentiWeb.jsm",TFoxOverlay.mod);
  window.addEventListener("load", TFoxOverlay.main, true);

}
