/* 
    This file is part of TFox.

    TFox is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TFox is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TFox. If not, see <http://www.gnu.org/licenses/>.
*/
var detUser = "";
function loadPrefs(){
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
    var interval   = prefs.getIntPref("extensions.tuentifox.datos.refreshTime")/(1000*60);
    var autoconect = prefs.getBoolPref("extensions.tuentifox.datos.autoconect");
    detUser        = prefs.getCharPref("extensions.tuentifox.datos.usuario");
    var enDwnLnk   = prefs.getBoolPref("extensions.tuentifox.datos.web.enabledownloadlink");
    var enImgTip   = prefs.getBoolPref("extensions.tuentifox.datos.web.enableimagetip");
    var TipWidth   = prefs.getIntPref("extensions.tuentifox.datos.web.imagetipwidth");
    var openLinks  = prefs.getBoolPref("extensions.tuentifox.datos.web.openlinksinnewtab");
    var enablecm   = prefs.getBoolPref("extensions.tuentifox.datos.web.enablecontextmenu");
    var enable   = prefs.getBoolPref("extensions.tuentifox.datos.web.enable");
    var classictags   = prefs.getBoolPref("extensions.tuentifox.datos.web.enableclassictags");
    var selectall   = prefs.getBoolPref("extensions.tuentifox.datos.web.enableselectall");
    var autoupdate   = prefs.getBoolPref("extensions.tuentifox.datos.enableupdate");
    
    document.getElementById("refresh_slider").value=interval;
    document.getElementById("autocon").checked = autoconect;
    document.getElementById("imageDownloadEnable").checked = enDwnLnk;
    document.getElementById("imageTipEnable").checked = enImgTip;
    document.getElementById("imageTipSize").selectedIndex = (TipWidth==200)?0:((TipWidth==500)?2:1);
    document.getElementById("openLinksIn").selectedIndex = openLinks?0:1;
    document.getElementById("uploadfromcm").checked = enablecm;
    document.getElementById("enableweb").checked = enable;
    document.getElementById("selectall").checked = selectall;
    document.getElementById("classictags").checked = classictags;
    document.getElementById("autoup").checked = autoupdate;
    refreshList();
    toogleEnableWeb();
    init_theme_events();
    
    if(window.arguments && window.arguments.length == 1){
	if(window.arguments[0].tab == "themes"){
	    document.getElementById("main-tabbox").selectedTab = document.getElementById("themes-tab");
	}
    }
}


const METADATA_START = "==tuentitheme==";

function getChromeURL(aTheme){
    return "chrome://tuentiaccessible/content/themes/"+
                (aTheme?aTheme+"/theme.css":"");       
}                                                      

function getFileFromChrome(aPath){
    var uri = Components.classes['@mozilla.org/network/io-service;1']
                        .getService(Components.interfaces.nsIIOService)
                        .newURI(aPath, "UTF-8", null);                 
    var rv = Components.classes['@mozilla.org/chrome/chrome-registry;1']
                       .getService(Components.interfaces.nsIChromeRegistry)
                       .convertChromeURL(uri).spec;                        
                                                                           
    return Components.classes["@mozilla.org/network/protocol;1?name=file"] 
            .createInstance(Components.interfaces.nsIFileProtocolHandler)  
            .getFileFromURLSpec(rv);                                       
}                                                                          

function getThemes(){
    var themes = []; 
    var file = getFileFromChrome(getChromeURL())
                .QueryInterface(Components.interfaces.nsILocalFile);
    if(file.isDirectory()){                                         
        var themeDirs = file.directoryEntries;                      
        while(themeDirs.hasMoreElements()){                         
            var themeDir = themeDirs.getNext()                      
                .QueryInterface(Components.interfaces.nsIFile);     
            //if(themeDir.leafName!="none")
	    themes.push(themeDir.leafName);
        }                                                               
    }                                                                   
    return themes;                                                      
}                                                                       

function getThemeRaw(aTheme){
    try{                     
        var xhr = new XMLHttpRequest();
        xhr.open("GET",getChromeURL(aTheme),false);
        xhr.overrideMimeType("text/plain");        
        xhr.send(null);                            
        return xhr.responseText;                   
    }catch(e){                                     
        return "";                                 
    }                                              
}                                                  

function getMetaData(aTheme){
    var datos = {            
        "theme": aTheme,     
        "author":"Desconocido",
        "name":"Desconocido",  
        "version":"0.0"        
    };                         
    var text = getThemeRaw(aTheme).substring(0,500);
    var index = text.indexOf(METADATA_START);       
                                                    
    if(index > 0){                                  
        text = text.substring(index + METADATA_START.length);
        var end = text.indexOf(METADATA_START);              
        if(end > 0)text=text.substring(0,end);               
        var trozos = text.split(/[\n\r]+/);                  
        for(var i = 0, l = trozos.length; i<l; i++){         
            if(/^\s*([a-zA-Z]+)\s*:\s*(\S(?:.*\S)?)\s*$/.test(trozos[i]) &&
               datos[RegExp.$1.toLowerCase()]){                            
                datos[RegExp.$1.toLowerCase()] = RegExp.$2;                
            }                                                              
        }                                                                  
    }                                                                      
    return datos;                                                          
}

function newThemeRow(elm){
    var nr = document.createElement("hbox");
    nr.setAttribute("untest","false");
    elm.appendChild(nr);
    return nr;
}


function themeparam(name,param,elm){
    var hb =document.createElement("hbox");
    var key = document.createElement("b");
    key.appendChild(document.createTextNode(name + ": "));
    var val = document.createElement("description");
    val.appendChild(key);
    val.appendChild(document.createTextNode(param));
    hb.appendChild(val);
    elm.appendChild(hb);
}

function newTheme(data,elm){
    var nt = document.createElement("image");
    nt.setAttribute("unset","false");
    nt.setAttribute("src","chrome://tuentiaccessible/content/themes/"+data.theme+"/icon.png");
    nt.setAttribute("id","theme-"+data.theme);
    nt.setAttribute("tooltip","tooltip_theme_" + data.theme );
    
    var tt = document.createElement("tooltip");
    var ttvb = document.createElement("vbox");
    
    themeparam("Nombre",data.name,ttvb);
    themeparam("Versión",data.version,ttvb);
    themeparam("Autor",data.author,ttvb);
    
    tt.appendChild(ttvb);
    tt.setAttribute("id","tooltip_theme_" + data.theme);
    
    document.documentElement.appendChild(tt);
    elm.appendChild(nt);
    return nt;
}

var wrapper = {};
Components.utils.import("resource://tuenti/TFox.jsm",wrapper);
var actualTheme = wrapper.TuentiTheme.getCurrentTheme();
var themes = [];
const THEMES_IN_ROW = 4; //Numero de temas en una fila
function init_theme_events(){
    themes = getThemes().map(getMetaData);
    
    var thelm = document.getElementById("themes");
    
    var row = newThemeRow(thelm);
    var temasfila = 0; //Numero de temas en esta fila
    var i = themes.length;
    while(i--){
	if(temasfila >= THEMES_IN_ROW){
	    row = newThemeRow(thelm);
	    temasfila = 0;
	}
	temasfila++;
	var theme = themes[i];
	var themeElm = newTheme(theme,row);
	bind_theme_events(themeElm,theme.theme);
	if(theme.theme == actualTheme){
	    themeElm.setAttribute("selected","true");
	}
    }
    
    
}
function bind_theme_events(themeElm,theme){
    themeElm.addEventListener("click",function(){change_theme(theme);},false);
    themeElm.addEventListener("mouseover",function(){test_theme(theme);},false);
    themeElm.addEventListener("mouseout",function(e){untest_theme(e);},false);
}
function change_theme(theme){
    wrapper.TuentiTheme.setCurrentTheme(theme);
    document.getElementById("theme-"+actualTheme).setAttribute("selected","false");
    actualTheme = wrapper.TuentiTheme.getCurrentTheme();
    document.getElementById("theme-"+actualTheme).setAttribute("selected","true");
}
function test_theme(theme){
    wrapper.TuentiTheme.setCurrentTheme(theme,true);
}
function untest_theme(e){
    if(e.relatedTarget && e.relatedTarget.hasAttribute("untest"))return;
    wrapper.TuentiTheme.setCurrentTheme(actualTheme,true);
}

function savePrefs(){
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    
    prefs.setIntPref("extensions.tuentifox.datos.refreshTime",document.getElementById("refresh_slider").value*1000*60);
    prefs.setBoolPref("extensions.tuentifox.datos.autoconect",document.getElementById("autocon").checked);
    prefs.setBoolPref("extensions.tuentifox.datos.web.enabledownloadlink",document.getElementById("imageDownloadEnable").checked);
    prefs.setBoolPref("extensions.tuentifox.datos.web.enableimagetip",document.getElementById("imageTipEnable").checked);
    prefs.setIntPref("extensions.tuentifox.datos.web.imagetipwidth",document.getElementById("imageTipSize").selectedIndex*150+200);
    prefs.setBoolPref("extensions.tuentifox.datos.web.openlinksinnewtab",document.getElementById("openLinksIn").selectedIndex==0);
    prefs.setBoolPref("extensions.tuentifox.datos.web.enable",document.getElementById("enableweb").checked);
    prefs.setBoolPref("extensions.tuentifox.datos.web.enableclassictags",document.getElementById("classictags").checked);
    prefs.setBoolPref("extensions.tuentifox.datos.web.enableselectall",document.getElementById("selectall").checked);
    prefs.setBoolPref("extensions.tuentifox.datos.web.enablecontextmenu",document.getElementById("uploadfromcm").checked);
    prefs.setBoolPref("extensions.tuentifox.datos.enableupdate",document.getElementById("autoup").checked);
    Application.storage.get("TuentiTimerStop",function(){})();  //stop the timer
    Application.storage.get("TuentiTimerStart",function(){})();  //start the timer
}

function refreshList(){
    
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefBranch);
    detUser = prefs.getCharPref("extensions.tuentifox.datos.usuario");   
    
    var aal = document.getElementById("users")
    
    while(aal.hasChildNodes()){aal.removeChild(aal.firstChild);}
    
    var users = getUsers();
    for(var i=0;i<users.length;i++){
        var li = document.createElement("listitem");
        li.setAttribute("label",users[i]);
        aal.appendChild(li);
    }
}


function toogleEnableWeb(){
	var disable = !document.getElementById("enableweb").checked;
	var ids = ["imageDownloadEnable","imageTipEnable","imageTipSize","uploadfromcm","selectall","classictags"];
	for each(var k in ids)
		document.getElementById(k).disabled = disable;
	if(!disable)toogleEnableSize();
}

function toogleEnableSize(){
    document.getElementById("imageTipSize").disabled = !document.getElementById("imageTipEnable").checked;
}

function getUsers(){
        var hostname = 'chrome://tuenti';
        var formSubmitURL = 'User - Pass';
        var httprealm = null;
        try {
           // Get Login Manager 
           var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
           // Find users for the given parameters
           var logins = myLoginManager.findLogins({}, hostname, formSubmitURL, httprealm);
              
           // Find user from returned array of nsILoginInfo objects
	   
	   var users=[];
           for (var i = 0; i < logins.length; i++) {
		users.push(logins[i].username);
           }
        }
        catch(ex) {
           // This will only happen if there is no nsILoginManager component class
        }
	return users;
}

function deleteUser(user){
        var hostname = 'chrome://tuenti';
        var formSubmitURL = 'User - Pass';
        var httprealm = null;
        var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
        myLoginManager.removeLogin(getLoginInfo(myLoginManager,user));
}

function newUser(user,pass,def){
    var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
    var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");
    var tfxLoginInfo = new nsLoginInfo('chrome://tuenti', 'User - Pass', null, user, pass, "", "");
    
    var oldLoginInfo = getLoginInfo(passwordManager,user);
    //If we are using an existing active user we should update the password
    
    if(oldLoginInfo != null) {                                   //if exists
        passwordManager.modifyLogin(oldLoginInfo, tfxLoginInfo); //edit it
    } else {                                                     //else
        passwordManager.addLogin(tfxLoginInfo);                  //add it
    }
    
    if(def){
        Application.prefs.setValue("extensions.tuentifox.datos.usuario", user);
        detUser = user;
    }
}

function getLoginInfo(lm,user){
    var hostname = 'chrome://tuenti';
    var formSubmitURL = 'User - Pass';
    var httprealm = null;
    
    try {
       // Find users for the given parameters
       var logins = lm.findLogins({}, hostname, formSubmitURL, httprealm);
       // Find user from returned array of nsILoginInfo objects
       for (var i = 0; i < logins.length; i++) {
          if (logins[i].username == user) {
             return logins[i];
          }
       }
    }
    catch(ex) {}
    return null;
}

function btnBorrarclick(){
    var aal = document.getElementById("users").currentItem;
    if(!aal){
        alert("Tienes que seleccionar uno");
        return;
    }
    var user = aal.getAttribute("label");
    if(confirm("Estas seguro de que quieres eliminar la cuenta " + user + "?")){
        deleteUser(user);
        refreshList();
    }
}


function btnNuevaClick(){
    document.getElementById("aalDeck").selectedIndex = 1;
    document.getElementById("user").value = "";        
    document.getElementById("password").value = "";
    document.getElementById("pred").checked = false;
}

function btnEditClick(){
    document.getElementById("aalDeck").selectedIndex = 1;
    var edtu = document.getElementById("users").currentItem.getAttribute("label");
    var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
    var li = getLoginInfo(passwordManager,edtu);
    if(!li)return;
    document.getElementById("user").value = li.username;        
    document.getElementById("password").value = li.password;
    document.getElementById("pred").checked = li.username==detUser;
    
    
}
function btnAceptarClick(){
    document.getElementById("aalDeck").selectedIndex = 0;
    
    var user = document.getElementById("user").value;
    var password = document.getElementById("password").value;
    var pred = document.getElementById("pred").checked;
    
    newUser(user,password,pred);
    
    refreshList();
    
    
}
function btnCancelarClick(){
    document.getElementById("aalDeck").selectedIndex = 0;
    
}

function url(spec) {
  var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
  return ios.newURI(spec, null, null);
}


function gotourl(e){
    var rl = "";
    if(typeof e == 'string')rl = e;
    else rl = e.getAttribute("href");
    
    Application.activeWindow.open(url(rl));
}



function openinvite(){
    window.openDialog("chrome://tuenti/content/tuentiInvite.xul","invite",'chrome');
}
