//En una funcion anonima para no crear las funciones globalmente

window.addEventListener("load",function(){
    //Copiado y pegado de https://wiki.mozilla.org/Labs/Ubiquity/Ubiquity_0.1_Author_Tutorial#Adding_Commands_Programmatically
    
    // Helper function used to determine the local directory where the
    // extension which contains the command is installed. This is used
    // to create the URL of the js file which includes the implementation
    // of the list of commands you want to add.
    function getExtensionDir() {
        var extMgr = Components.classes["@mozilla.org/extensions/manager;1"]
                     .getService(Components.interfaces.nsIExtensionManager);
        return extMgr.getInstallLocation( "tuentifox@mozilla-hispano.org" ).getItemLocation( "tuentifox@mozilla-hispano.org" );
    }
    
    function getBaseUri() {
        var ioSvc = Components.classes["@mozilla.org/network/io-service;1"]
                              .getService(Components.interfaces.nsIIOService);
        var extDir = getExtensionDir();
        var baseUri = ioSvc.newFileURI(extDir).spec;
        return baseUri;
    }
    
    // your extension needs to call the addUbiquity command each time a new browser
    // session is create and your extension is loaded.
    function addUbiquityCommands(){
        try{
            // url of the file which contains the implementation of the commands
            // we want to add. 
            var url = getBaseUri() + "chrome/content/tuentiUbiquityImp.js";
            
            // link to the ubiquity setup module.
            var jsm = {}; 
            Components.utils.import("resource://ubiquity/modules/setup.js", jsm); 
            
            // look up the feed manager and add a new command. Note: we are using the
            // isBuiltIn=true option so that the command is only added for the duration
            // of the browser session. This simplifies the overall lifecycle: if the
            // extension is disabled or un-installed, it will be automatically
            // "removed" from ubiquity.
            jsm.UbiquitySetup.createServices().feedManager.addSubscribedFeed( {
                url: url,
                sourceUrl: url,
                canAutoUpdate: true,
                isBuiltIn: true
            });
        }catch(e){
            //Ubiquity no esta instalado
        }
    }
    
    window['setTimeout'](addUbiquityCommands,100);

},false);
