//TODO: Con la version 0.5 de ubiquity hay que actualizar los comandos

//Constantes, para poder cambiar todos los comandos a la vez.
const icon = "chrome://tuenti/content/img/icon.png",
homepage   = "http://www.mozilla-hispano.org/labs/tfox/",
author     = { name: "Mozilla Hispano Labs", email: "youwotma@mozilla-hispano.org"},  //TODO: Cambiar el email
license    = "GPL";


var API = {};
Components.utils.import("resource://tuenti/tuentiAPI.jsm",API);

const accents         = ['á','é','í','ó','ú','ü','ö'];
const no_accents      = ['a','e','i','o','u','u','o'];


function stripAccents(text){
        text = text.toLowerCase().replace(/^\s*/,'').replace(/\s*$/,'');
        for (var letter in accents){
                text = text.replace(new RegExp(accents[letter],"ig"),no_accents[letter]);
        }
        return " " + text.replace(/[^a-zñ ]/gm,'');
}



var tuenti_friend = {
  _name: "Amigo de tuenti",
  suggest: function( text, html ) {
    
    if(!API.TuentiProxy.isConnected()){
        return [];
    }
    
    
    var t = API.TuentiProxy.friends;
    var res = [];
    if(text == "" || /^\s*$/.test(text)){
      for(var k in t){
          res.push(CmdUtils.makeSugg(t[k].nick));
          if(res.length>=5)return res;
      }
      return res;
    }
    
    var f = stripAccents(text);
      for each(var k in t){
        if(k.fnick.indexOf(f)>=0){
          res.push(CmdUtils.makeSugg(k.nick));
          if(res.length>=5)return res;
        }
      }
          
          
    return res;
  }
}


if (CmdUtils.parserVersion == 2){


CmdUtils.CreateCommand({
    names: ["tuenti-msg","mensaje tuenti","enviar como mensaje por tuenti"],
    icon: icon,
    homepage: homepage,
    author: author,
    license: license,
    description: "Envia un mensaje privado a un amigo de tuenti",
    help: "Nesesitas tener TFox y estar conectado a una cuenta de tuenti mediante TFox para usarlo. Escribe 'tuenti-msg [el texto] to [nombre del destinatario]'",
    //takes: {Texto:noun_arb_text},
    //modifiers: {to:tuenti_friend},
    arguments: [{role: 'object', nountype: noun_arb_text, label: 'mensaje'},
                {role: 'goal', nountype: tuenti_friend, label: 'amigo de tuenti'} ],
    preview: function( pblock, args) {
        if(!API.TuentiProxy.isConnected()){
            pblock.innerHTML = "Nesesitas estar conectado a TFox para usar este comando";
            return;
        }
    
        var html = "Envia <b>" + args.object.text + "</b>";
    
        if(args.goal && args.goal.text != ""){
            var r = API.TuentiProxy.findFriend2(args.goal.text);
            html += " a " + r[0].replace('|','<b>').replace('|','</b>');
        }
    
        html += " como mensaje privado en tuenti";
        pblock.innerHTML = html;
    },
    execute: function(mods) {
        if(!API.TuentiProxy.isConnected()){
            displayMessage("Nesesitas estas conectado a TFox para usar este comando");
            return;
        }

        var f = API.TuentiProxy.findFriend2(mods.goal.text);
        
        if(!f || !f[0]){
                displayMessage("Ocurrio un error al enviar el mensaje. El mensaje no se ha enviado");
                return;
        }
        
        f = API.TuentiProxy.getFriendByName(f[0]);
        
        API.TuentiProxy.sendPrivateMessage(f.id,mods.object.text,function(r){
                if(r){
                    displayMessage("El mensaje se ha enviado correctamente.");
                }else{
                    displayMessage("Ocurrio un error al enviar el mensaje. El mensaje no se ha enviado");
                }   
        });

    }
});










CmdUtils.CreateCommand({
    names: ["tuenti-wall","comentario tuenti","enviar como comentario por tuenti"],
    icon: icon,
    homepage: homepage,
    author: author,
    license: license,
    description: "Envia un comentario en el tablon de un amigo de tuenti",
    help: "Nesesitas tener TFox y estar conectado a una cuenta de tuenti mediante TFox para usarlo. Escribe 'tuenti-wall [el texto] to [nombre del destinatario]'",
    //takes: {Texto:noun_arb_text},
   // modifiers: {to:tuenti_friend},
    arguments: [{role: 'object', nountype: noun_arb_text, label: 'comentario'},
                {role: 'goal', nountype: tuenti_friend, label: 'amigo de tuenti'} ],
    preview: function( pblock, args) {
        if(!API.TuentiProxy.isConnected()){
            pblock.innerHTML = "Nesesitas estar conectado a TFox para usar este comando";
            return;
        }
    
        var html = "Envia <b>" + args.object.text + "</b>";
    
        if(args.to && args.goal.text != ""){
            var r = API.TuentiProxy.findFriend2(args.to.text);
            html += " a " + r[0].replace('|','<b>').replace('|','</b>');
        }
    
        html += " como comentario en su tablon de tuenti";
        pblock.innerHTML = html;
    },
    execute: function(mods) {
        if(!API.TuentiProxy.isConnected()){
            displayMessage("Nesesitas estas conectado a TFox para usar este comando");
            return;
        }

        var f = API.TuentiProxy.findFriend2(mods.goal.text);
        
        if(!f || !f[0]){
                displayMessage("Ocurrio un error al enviar el comentario. El comentario no se ha enviado");
                return;
        }
        
        f = API.TuentiProxy.getFriendByName(f[0]);
        
        API.TuentiProxy.sendTablonMessage(f.id,mods.object.text,function(r){
                if(r){
                    displayMessage("El comentario se ha enviado correctamente.");
                }else{
                    displayMessage("Ocurrio un error al enviar el comentario. El comentario no se ha enviado");
                }   
        });

    }
});



CmdUtils.CreateCommand({
    names: ["tuenti-profile","ver el perfil de tuenti","perfil tuenti"],
    icon: icon,
    homepage: homepage,
    author: author,
    license: license,
    description: "Abre el perfil de un amigo de tuenti",
    help: "Nesesitas tener TFox y estar conectado a una cuenta de tuenti mediante TFox para usarlo. Escribe 'tuenti-profile of [nombre del amigo]'",
    //takes: {},
    //modifiers: {of:tuenti_friend},
    arguments: [{role: 'goal', nountype: tuenti_friend, label: 'amigo de tuenti'}],
    preview: function( pblock,mods) {
        if(!API.TuentiProxy.isConnected()){
            pblock.innerHTML = "Nesesitas estar conectado a TFox para usar este comando";
            return;
        }
    
        var html = "Abre ";
    
        if(mods.goal && mods.goal.text != ""){
            var r = API.TuentiProxy.findFriend2(mods.goal.text);
            html += " el perfil de tuenti de " + r[0].replace('|','<b>').replace('|','</b>');
        }else{
            html += " tu perfil de tuenti."
        }
        pblock.innerHTML = html;
    },
    execute: function(mods) {
        if(!API.TuentiProxy.isConnected()){
            displayMessage("Nesesitas estas conectado a TFox para usar este comando");
            return;
        }

        if(mods && mods.goal && mods.goal.text){
                var f = API.TuentiProxy.findFriend2(mods.goal.text);
                if(f && f[0]){
                        f = API.TuentiProxy.getFriendByName(f[0]);
                        Utils.openUrlInBrowser("http://www.tuenti.com/#m=Profile&func=index&user_id=" + f.id);
                }
        }else{
                Utils.openUrlInBrowser("http://www.tuenti.com/#m=Profile&func=index");
        }
    }
});







CmdUtils.CreateCommand({
    name: ["tuenti-status","estado tuenti","cambiar el estado de tuenti"],
    icon: icon,
    homepage: homepage,
    author: author,
    license: license,
    description: "Cambia tu estado en tuenti",
    help: "Nesesitas tener TFox y estar conectado a una cuenta de tuenti mediante TFox para usarlo. Escribe 'tuenti-statud [nuevo estado]'",
    //takes: {Estado:noun_arb_text},
    //modifiers: {},
    arguments: [{role: 'object', nountype: noun_arb_text, label: 'nuevo estado'}],
    preview: function( pblock, args) {
        if(!API.TuentiProxy.isConnected()){
            pblock.innerHTML = "Nesesitas estar conectado a TFox para usar este comando";
            return;
        }
    
        var html = "Cambia tu estado en tuenti a  <b>" + input.text + "</b>";
    
        pblock.innerHTML = html;
    },
    execute: function(mods) {
        if(!API.TuentiProxy.isConnected()){
            displayMessage("Nesesitas estas conectado a TFox para usar este comando");
            return;
        }
        
        API.TuentiProxy.setStatus(mods.object.text,function(r){
                if(r){
                    displayMessage("El estado se ha actualizado correctamente.");
                }else{
                    displayMessage("Ocurrio un error al actualizar el estado. El estado no se ha actualizado");
                }   
        });

    }
});




}else{
        
        CmdUtils.CreateCommand({
    name: "tuenti-msg",
    icon: icon,
    homepage: homepage,
    author: author,
    license: license,
    description: "Envia un mensaje privado a un amigo de tuenti",
    help: "Nesesitas tener TFox y estar conectado a una cuenta de tuenti mediante TFox para usarlo. Escribe 'tuenti-msg [el texto] to [nombre del destinatario]'",
    takes: {Texto:noun_arb_text},
    modifiers: {to:tuenti_friend},
    preview: function( pblock, input ,mods) {
        if(!API.TuentiProxy.isConnected()){
            pblock.innerHTML = "Nesesitas estar conectado a TFox para usar este comando";
            return;
        }
    
        var html = "Envia <b>" + input.text + "</b>";
    
        if(mods.to && mods.to.text != "" && mods.to != {}){
            var r = API.TuentiProxy.findFriend2(mods.to.text);
            html += " a " + r[0].replace('|','<b>').replace('|','</b>');
        }
    
        html += " como mensaje privado en tuenti";
        pblock.innerHTML = html;
    },
    execute: function(input,mods) {
        if(!API.TuentiProxy.isConnected()){
            displayMessage("Nesesitas estas conectado a TFox para usar este comando");
            return;
        }

        var f = API.TuentiProxy.findFriend2(mods.to.text);
        
        if(!f || !f[0]){
                displayMessage("Ocurrio un error al enviar el mensaje. El mensaje no se ha enviado");
                return;
        }
        
        f = API.TuentiProxy.getFriendByName(f[0]);
        
        API.TuentiProxy.sendPrivateMessage(f.id,input.text,function(r){
                if(r){
                    displayMessage("El mensaje se ha enviado correctamente.");
                }else{
                    displayMessage("Ocurrio un error al enviar el mensaje. El mensaje no se ha enviado");
                }   
        });

    }
});










CmdUtils.CreateCommand({
    name: "tuenti-wall",
    icon: icon,
    homepage: homepage,
    author: author,
    license: license,
    description: "Envia un comentario en el tablon de un amigo de tuenti",
    help: "Nesesitas tener TFox y estar conectado a una cuenta de tuenti mediante TFox para usarlo. Escribe 'tuenti-wall [el texto] to [nombre del destinatario]'",
    takes: {Texto:noun_arb_text},
    modifiers: {to:tuenti_friend},
    preview: function( pblock, input ,mods) {
        if(!API.TuentiProxy.isConnected()){
            pblock.innerHTML = "Nesesitas estar conectado a TFox para usar este comando";
            return;
        }
    
        var html = "Envia <b>" + input.text + "</b>";
    
        if(mods.to && mods.to.text != "" && mods.to != {}){
            var r = API.TuentiProxy.findFriend2(mods.to.text);
            html += " a " + r[0].replace('|','<b>').replace('|','</b>');
        }
    
        html += " como comentario en su tablon de tuenti";
        pblock.innerHTML = html;
    },
    execute: function(input,mods) {
        if(!API.TuentiProxy.isConnected()){
            displayMessage("Nesesitas estas conectado a TFox para usar este comando");
            return;
        }

        var f = API.TuentiProxy.findFriend2(mods.to.text);
        
        if(!f || !f[0]){
                displayMessage("Ocurrio un error al enviar el comentario. El comentario no se ha enviado");
                return;
        }
        
        f = API.TuentiProxy.getFriendByName(f[0]);
        
        API.TuentiProxy.sendTablonMessage(f.id,input.text,function(r){
                if(r){
                    displayMessage("El comentario se ha enviado correctamente.");
                }else{
                    displayMessage("Ocurrio un error al enviar el comentario. El comentario no se ha enviado");
                }   
        });

    }
});









CmdUtils.CreateCommand({
    name: "tuenti-profile",
    icon: icon,
    homepage: homepage,
    author: author,
    license: license,
    description: "Abre el perfil de un amigo de tuenti",
    help: "Nesesitas tener TFox y estar conectado a una cuenta de tuenti mediante TFox para usarlo. Escribe 'tuenti-profile of [nombre del amigo]'",
    takes: {},
    modifiers: {of:tuenti_friend},
    preview: function( pblock, input ,mods) {
        if(!API.TuentiProxy.isConnected()){
            pblock.innerHTML = "Nesesitas estar conectado a TFox para usar este comando";
            return;
        }
    
        var html = "Abre ";
    
        if(mods.of && mods.of.text != "" && mods.of != {}){
            var r = API.TuentiProxy.findFriend2(mods.of.text);
            html += " el perfil de tuenti de " + r[0].replace('|','<b>').replace('|','</b>');
        }else{
            html += " tu perfil de tuenti."
        }
        pblock.innerHTML = html;
    },
    execute: function(input,mods) {
        if(!API.TuentiProxy.isConnected()){
            displayMessage("Nesesitas estas conectado a TFox para usar este comando");
            return;
        }

        if(mods && mods.of && mods.of.text){
                var f = API.TuentiProxy.findFriend2(mods.of.text);
                if(f && f[0]){
                        f = API.TuentiProxy.getFriendByName(f[0]);
                        Utils.openUrlInBrowser("http://www.tuenti.com/#m=Profile&func=index&user_id=" + f.id);
                }
        }else{
                Utils.openUrlInBrowser("http://www.tuenti.com/#m=Profile&func=index");
        }
    }
});







CmdUtils.CreateCommand({
    name: "tuenti-status",
    icon: icon,
    homepage: homepage,
    author: author,
    license: license,
    description: "Cambia tu estado en tuenti",
    help: "Nesesitas tener TFox y estar conectado a una cuenta de tuenti mediante TFox para usarlo. Escribe 'tuenti-statud [nuevo estado]'",
    takes: {Estado:noun_arb_text},
    modifiers: {},
    preview: function( pblock, input ,mods) {
        if(!API.TuentiProxy.isConnected()){
            pblock.innerHTML = "Nesesitas estar conectado a TFox para usar este comando";
            return;
        }
    
        var html = "Cambia tu estado en tuenti a  <b>" + input.text + "</b>";
    
        pblock.innerHTML = html;
    },
    execute: function(input,mods) {
        if(!API.TuentiProxy.isConnected()){
            displayMessage("Nesesitas estas conectado a TFox para usar este comando");
            return;
        }
        
        API.TuentiProxy.setStatus(input.text,function(r){
                if(r){
                    displayMessage("El estado se ha actualizado correctamente.");
                }else{
                    displayMessage("Ocurrio un error al actualizar el estado. El estado no se ha actualizado");
                }   
        });

    }
});

        
}