/* 
    This file is part of TFox.

    TFox is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TFox is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TFox. If not, see <http://www.gnu.org/licenses/>.
*/
function prefsave(){
    
    var usertexbox = document.getElementById("tuentiUsernameText");
    var username = usertexbox.value;
    var passtexbox = document.getElementById("tuentiPassText");
    var password = passtexbox.value;
    
    if(username=="" || password==""){
        alert("El nombre de usuario o la contrasea no pueden estar vacios");  //FIXME: the string shoug go in the properties file
        return;
    }
    
    if(!document.getElementById("RemPwd").checked){
        var fun =Application.storage.get("TuentiReconectFnc",null);
        if(fun)fun(username,password);
        return;
    }
    
    // Login manager stuff
    var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
    var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");
    var tfxLoginInfo = new nsLoginInfo('chrome://tuenti', 'User - Pass', null, username, password, "", "");
    
    var oldLoginInfo = getLoginInfo(passwordManager,username);
    //If we are using an existing active user we should update the password
    
    if(oldLoginInfo != null) {                                   //if exists
        passwordManager.modifyLogin(oldLoginInfo, tfxLoginInfo); //edit it
    } else {                                                     //else
        passwordManager.addLogin(tfxLoginInfo);                  //add it
    }
    
    if(document.getElementById("MkeDft").getAttribute("checked") =="true"){
        Application.prefs.setValue("extensions.tuentifox.datos.usuario", username);
    }
    
    
    //login with the new user
    var fun =Application.storage.get("TuentiReconectFnc",null);
    if(fun)fun(username);
}

function getAllLogins(){
    var hostname = 'chrome://tuenti';
    var formSubmitURL = 'User - Pass';
    var httprealm = null;
    var lm = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
    return lm.findLogins({}, hostname, formSubmitURL, httprealm);
}



function refreshCombo(){
    var logins = getAllLogins();
    var user = mh(document.getElementById("menuuser").firstChild).empty();
    for each(var k in logins)
        user.append(mh().create("menuitem").attr("label",k.username)[0]);
}

function refreshImage(user){
    var f = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
    f.append("TFox");
    f.append(user.replace(/[^a-z0-9@\-_\.]/gi,"_"));
    f.append("foto.jpg");
    document.getElementById("login_photo").setAttribute("src",f.exists()?getURLFromFile(f):"chrome://tuenti/content/img/no_foto.jpg")
}

function refreshConfig(){
    var user = document.getElementById("menuuser").value;
    var isDef = Application.prefs.getValue("extensions.tuentifox.datos.usuario","EPIC FAIL") == user;
    
    var re = getAllLogins();
    var saved = false;
    var pass = "";
    for each(var k in re)
        if(k.username == user){
            saved = true;
            pass = k.password;
            break;
        }
    
    var CheckUserPass = document.getElementById("RemUsrPwd");
    var CheckAutoLogin = document.getElementById("AutoLogin");
    var txtPass = document.getElementById("tuentiPassText");
    CheckUserPass.checked = saved;
    CheckUserPass.disabled = isDef;
    txtPass.disabled = saved;
    txtPass.value = pass;
    CheckAutoLogin.disabled = !saved;
    CheckAutoLogin.checked = isDef;
    refreshImage(user);
}


function saveUserPassCommand(){
    var hostname = 'chrome://tuenti';
    var formSubmitURL = 'User - Pass';
    var httprealm = null;
    var user = document.getElementById("menuuser").value;
    var lm = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
    var re = lm.findLogins({}, hostname, formSubmitURL, httprealm);
    for each(var k in re)
        if(k.username == user){
            lm.removeLogin(k);
            refreshConfig();
            return;
        }
        
    var newli = Components.classes["@mozilla.org/login-manager/loginInfo;1"].createInstance(Components.interfaces.nsILoginInfo);
    newli.init(hostname,formSubmitURL,httprealm,user,document.getElementById("tuentiPassText").value,"","");
    lm.addLogin(newli);
    refreshConfig();
    refreshCombo();
}

function connectCommmand(){
    Application.storage.get("TuentiReconectFnc",function(){})(
        document.getElementById("menuuser").value,
        document.getElementById("tuentiPassText").value
    );
}

function autoLoginCommand(){
    if(document.getElementById("AutoLogin").checked)
        Application.prefs.setValue("extensions.tuentifox.datos.usuario",document.getElementById("menuuser").value);
    else
        Application.prefs.setValue("extensions.tuentifox.datos.usuario","");
    refreshConfig();
}


function getURLFromFile(aFile) {
    var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
    return fileHandler.getURLSpecFromFile(aFile);
}

function main() {
    refreshCombo();
}
window.addEventListener("load", main, true);
