﻿/* 
    This file is part of TFox.

    TFox is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TFox is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TFox. If not, see <http://www.gnu.org/licenses/>.
*/
Components.utils.import("resource://tuenti/tuentiAPI.jsm"); 
var openLinksInNewTab = true;
var searchQuery = "";

var tuentiPrefObserver = {
  register: function(){
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);    // First we'll need the preference services to look for preferences.
    this._branch = prefService.getBranch("extensions.tuentifox.datos.web.");    // For this._branch we ask that the preferences for extensions.myextension. and children
    this._branch.QueryInterface(Components.interfaces.nsIPrefBranch2);// "nsIPrefBranch2 allows clients to observe changes to pref values."    // Now we queue the interface called nsIPrefBranch2. This interface is described as:  
    this._branch.addObserver("", this, false);// Finally add the observer.
  },
  unregister: function(){
    if(!this._branch) return;
    this._branch.removeObserver("", this);
  },
  observe: function(aSubject, aTopic, aData){
    if(aTopic != "nsPref:changed" || aData != "openlinksinnewtab") return;
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    openLinksInNewTab = prefService.getBoolPref("extensions.tuentifox.datos.web.openlinksinnewtab");
  }
};

function createUserElt(friend,strbundle) {
  
  var id = friend.id;
  
  var bbox = document.createElementNS("http://www.w3.org/1999/xhtml","html:div");
  
  if(friend.act){
    if(friend.act.pictstag)
	    bbox.appendChild(createNewImagesLink(friend.act.pictstag,friend.act.thumbs,strbundle,id));
    if(friend.act.pictsup)
	    bbox.appendChild(createNewImagesUpLink(friend.act.pictsup,friend.act.thumbs,strbundle,id));
    if(friend.act.friends)
	    bbox.appendChild(createNewFriendLink(friend.act.friends,strbundle));
    if(friend.act.comments)
	    bbox.appendChild(createNewCommentLink(friend.act.comments,friend.act.commentsFromOthers,friend.act.commentsFromFriends,strbundle));
    if(friend.act.blog)
	    bbox.appendChild(createNewBlogLink(friend.act.blog,strbundle,id));
  }
  
  return mh.prototype.fromJSON({
    tag: 'tuentifriend',
    attr: {
      tuentiid: id,
      image: friend.imgf(30),
      bigimage: friend.imgf(200),
      nick: friend.nick,
      status: friend.status
    }
  }).append(bbox).addClass("tuentiFriend").attr("tuentiname",friend.nick)[0];
}


function createSimpleUserElt(name,id,img,strbundle){
  var fr = document.createElement("hbox");
  var vbox = document.createElement("vbox");
  vbox.setAttribute("flex","1"); 
  fr.setAttribute("class", "tuentiFriend");
  fr.setAttribute("tuentiname",name);
   /*
   *FRIEND IMAGE
   */
  var imagevbox=document.createElement("vbox");
  var space = document.createElement("spacer");
  space.setAttribute("flex","1");
  imagevbox.appendChild(createImage(img(30) , "http://www.tuenti.com/#m=Profile&func=index&user_id="+id , "tuentiFriendImage","tooltip_"+id,img(200)));
  imagevbox.appendChild(space);
  fr.appendChild(imagevbox);
  
  /*
   *FRIEND NICK
   */  
  var nickElt = document.createElement("label");  
  nickElt.setAttribute("value", name);  
  nickElt.setAttribute("class", "nick");  
  vbox.appendChild(nickElt);
  fr.appendChild(vbox);
  /*
   *TOOLS
   */
  var toolsvbox = document.createElement("vbox");
  //toolsvbox.appendChild(createMsgButton(id));
  toolsvbox.appendChild(createProfileButton(id));
  //toolsvbox.appendChild(createCommentButton(id));
  toolsvbox.setAttribute("class","tuentiFriendTools");
  fr.appendChild(toolsvbox);
  fr.setAttribute("collapsed","true");
  return fr;
}
function wrapText(txt){
  var d = document.createElement("description");
  d.appendChild(document.createTextNode(txt));
  return d;
}
function createNewImagesLink(data,data2,strbundle,id){
	var link = document.createElement("description");
	link.setAttribute("class","actLink");
	link.setAttribute("href",data.url);
	var photoTxt = ' ' + strbundle.getString('photo');
	link.appendChild(wrapText(data.count + photoTxt + (data.count>1?"s":"")));
	link.addEventListener("click",function(event){followLink(link);},true);
	if(data2){
	  var tooltipth = document.createElement("tooltip");
	  for(var k in data2){
		var imagetipth = document.createElement("image");
		imagetipth.setAttribute("src",data2[k].imgf(200));
		tooltipth.appendChild(imagetipth);
		var space = document.createElement("spacer");
		space.setAttribute("height","3");
		tooltipth.appendChild(space);
	  }
	  var tipidth = "tooltip_th_" + id;
	  tooltipth.setAttribute("id",tipidth);
	  link.appendChild(tooltipth);
	  link.setAttribute("tooltip",tipidth);
	}
	
	return link;
}
function createContextMenu(id,str){
  var popset = document.createElement("popupset");
  var pop = document.createElement("menupopup");
  var sendPM = document.createElement("menuitem");
  var sendCM = document.createElement("menuitem");
  var perfil = document.createElement("menuitem");
  var grupos = document.createElement("menuitem");
  sendPM.setAttribute("label",str.getString("contextsendPM"));
  sendCM.setAttribute("label",str.getString("contextsendCM"));
  perfil.setAttribute("label",str.getString("contextverPerfil"));
  grupos.setAttribute("label",str.getString("contextgrupos"));
  sendPM.addEventListener("command",function(){
      openMsgWindowById(id);
    },false);
  sendCM.addEventListener("command",function(){
      openComWindowById(id);
    },false);
  perfil.addEventListener("command",function(){
      gotoURL("http://www.tuenti.com/#m=Profile&func=index&user_id=" + id);
    },false);
  grupos.addEventListener("command",function(){
      window.openDialog("chrome://tuenti/content/tuentiGroups.xul","Grupos","chrome,modal,centerscreen",{id:id});
    },false);
  popset.appendChild(pop);
  pop.appendChild(sendPM);
  pop.appendChild(sendCM);
  pop.appendChild(perfil);
  pop.appendChild(grupos );
  return pop;
}

function createNewImagesUpLink(data,data2,strbundle,id){
  	var link = document.createElement("description");
	link.setAttribute("class","actLink");
	link.setAttribute("href",data.url);
	link.appendChild(wrapText(strbundle.getFormattedString("fotossubidas",[data.count,data.count>1?"s":"",data.count>1?"s":""])));
	link.addEventListener("click",function(event){followLink(link);},true);
	if(data2){
	  var tooltipth = document.createElement("tooltip");
	  for(var k in data2){
		var imagetipth = document.createElement("image");
		imagetipth.setAttribute("src",data2[k].imgf(200));
		tooltipth.appendChild(imagetipth);
		var space = document.createElement("spacer");
		space.setAttribute("height","3");
		tooltipth.appendChild(space);
	  }
	  var tipidth = "tooltip_th_up_" + id;
	  tooltipth.setAttribute("id",tipidth);
	  link.appendChild(tooltipth);
	  link.setAttribute("tooltip",tipidth);
	}
	
	return link;
  
}
function createNewFriendLink(data,strbundle){
  var link = document.createElement("description");
  link.setAttribute("class","actLink");
  link.setAttribute("href",data.url);
  
  var friendTxt = ' ' + strbundle.getString('friend');
  link.appendChild(wrapText(data.count + friendTxt + (data.count>1?"s":"")));
  
  link.setAttribute("tooltiptext",data.name);
  link.addEventListener("click",function(event){followLink(link);},true);
  return link;
}
function createNewCommentLink(data,cfo,cff,strbundle){
	var link = document.createElement("description");
	link.setAttribute("class","actLink");
	link.setAttribute("href",data.url);
	var commentTxt = ' ' + strbundle.getString('comment') ;
	link.appendChild(wrapText( data.count + commentTxt + (data.count>1?"s":"")));
	
	if(cfo || cff){
		var tip = document.createElement("tooltip");
		
		for each(var k in cff){
			var hbox = document.createElement("hbox");
			var txt = document.createElement("label");
			var nick = document.createElement("label");
			txt.setAttribute("class","commentsprevtxt");
			nick.setAttribute("class","commentsprevnick");
			txt.appendChild(document.createTextNode(k.txt));
			nick.appendChild(document.createTextNode(k.nick));
			hbox.appendChild(txt);
			hbox.appendChild(nick);
			tip.appendChild(hbox);
		}
		
		if(cfo){
			var des = document.createElement("label");
			des.setAttribute("class","commentsfromothers");
			des.setAttribute("value",strbundle.getFormattedString(cfo<=1?"commentfromother":"commentsfromothers",[cfo]));
			tip.appendChild(des);
		}
		
		link.appendChild(tip);
		link.setAttribute("tooltip","_child");
	}
	
	
	link.addEventListener("click",function(event){followLink(link);},true);
	return link;
}
function createNewBlogLink(data,strbundle,id){
	var link = document.createElement("description");
	link.setAttribute("class","actLink");
	link.setAttribute("href",data.url);
	var onePostTxt = strbundle.getString('1post');
	link.appendChild(document.createTextNode(onePostTxt));
	link.addEventListener("click",function(event){followLink(link);},true);
	var tooltipth = document.createElement("tooltip");
	
	var title = document.createElement("label");
	title.setAttribute("value",data.title);
	title.setAttribute("class", "blogTitle");
	
	var text = document.createElement("description");
	text.setAttribute("class","blogText");
	text.appendChild(document.createTextNode(data.text));
	
	tooltipth.appendChild(title);
	tooltipth.appendChild(text);
	
	var tipidth = "tooltip_bg_" + id;
	tooltipth.setAttribute("id",tipidth);
	link.appendChild(tooltipth);
	link.setAttribute("tooltip",tipidth);
	return link;
}


function createMsgElm(msg){
  
  var f = TuentiProxy.getFriendByName(msg.nick);
  var imgurl = f?f.imgf(30):TuentiProxy._getImgFunction("sad");
  
  return mh().create("tuentimsg").attr({
      nick: msg.nick,
      date: msg.when,
      img: imgurl
  }).append(document.createTextNode(msg.txt)).flex(1).click(function(){
      var elm = mh(this).empty().append(mh("<image>").attr("src","chrome://global/skin/icons/loading_16.png")[0]);
      TuentiProxy.getFullMsg(function(result){
	  if(!result)return;
	  elm.empty().append(createTextWithLinks(result));
      },msg.url);
  })[0];
  
  
  var vbox = document.createElement("vbox");
  var hbox = document.createElement("hbox");
  var hbox2 = document.createElement("hbox");
  
  var user = document.createElement("label");
  var when = document.createElement("label");
  var text = document.createElement("vbox");
  
  //text.addEventListener("click",function(event){setReaded(event);},true);
  
  user.setAttribute("value", msg.nick);
  when.setAttribute("value", msg.when);
  text.appendChild(createTextWithLinks(msg.txt));
  
  text.setAttribute("class", "MsgTxt");
  user.setAttribute("class", "MsgUser");
  when.setAttribute("class", "MsgWhen")
  
  hbox.appendChild(user);
  hbox.appendChild(when);
  
  hbox.setAttribute("new",msg.nuevo);
  
  
  var imgurl = f?f.imgf(30):TuentiProxy._getImgFunction("sad")(30);
  
  var img = document.createElement("image");
  img.setAttribute("src",imgurl);
  
  hbox2.appendChild(img);
  hbox2.appendChild(vbox);
  
  hbox2.className = "pMsgContainer";
  
  vbox.appendChild(hbox);
  vbox.appendChild(text);
  
  hbox2.setAttribute("href","http://www.tuenti.com/#m=Message&func=index");
  
  hbox2.addEventListener("click",function(){
    followLink(hbox2);  
  },true);
  
  return hbox2;
}
function createComElm(com){
  var hbox = document.createElement("hbox");
  var vbox = document.createElement("vbox");
  var vbox2 = document.createElement("vbox");
  
  var user = document.createElement("label");
  var when = document.createElement("label");
  var acts = document.createElement("hbox");
  var text = document.createElement("vbox");
  
  var id = com.user_id;
  acts.appendChild(user);
  acts.appendChild(createMsgButton(id));
  acts.appendChild(createProfileButton(id));
  acts.appendChild(createCommentButton(id));
  
  user.setAttribute("value", com.nick);
  when.setAttribute("value", com.when);
  
  text.appendChild(createTextWithLinks(com.text));
  
  user.setAttribute("class", "MsgUser");
  vbox.setAttribute("class", "MsgBox");
  hbox.setAttribute("class", "MsgHeader");
  when.setAttribute("class", "MsgWhen")
    
  vbox2.appendChild(acts);
  vbox2.appendChild(when);
  
  hbox.appendChild(createImage(com.imgf(30) , "http://www.tuenti.com/#m=Profile&func=index&user_id="+id , "MsgImg","tooltip_com_"+id,com.imgf(200)));
  hbox.appendChild(vbox2);
  
  vbox.appendChild(hbox);
  vbox.appendChild(text);
  
  vbox.setAttribute("new",com.nuevo);
  
  return vbox;
}

function createImageElm(img,strbundle){
  var hbox   = document.createElement("hbox");
  var vbox   = document.createElement("vbox");
  var image  = document.createElement("image");
  var acts   = document.createElement("hbox");
  var buttons   = document.createElement("hbox");
  var nick   = document.createElement("label");
  var title  = document.createElement("label");
  
  hbox.setAttribute("class", "tuentiPictsBox")
  image.setAttribute("src",img.imgURL);
  image.setAttribute("href",img.url);
  image.addEventListener("click",function(event){followLink(image);},true);
  image.setAttribute("class", "tuentiPict");

  var uploadedbyTxt = strbundle.getString('uploadedby') + ' ';
  
  if(img.uploadedbyyou)
      nick.setAttribute("value", uploadedbyTxt + strbundle.getString('uploadedbyyou'));
  else if(img.uploaderisnotafriend)
      nick.setAttribute("value", uploadedbyTxt + strbundle.getString('uploadedbynotafriend'));
  else
      nick.setAttribute("value", uploadedbyTxt + img.uploader);
  
  title.setAttribute("value",img.title);
  buttons.setAttribute("class", "tuentiFriendTools")
  acts.appendChild(nick);
  
  if(!img.uploadedbyyou){
    var id = img.upid;
    buttons.appendChild(createMsgButton(id));
    buttons.appendChild(createProfileButton(id));
    buttons.appendChild(createCommentButton(id));
  }
  
  hbox.appendChild(image);
  hbox.appendChild(vbox);
  
  vbox.appendChild(title);
  vbox.appendChild(acts);
  vbox.appendChild(buttons);
  
  return hbox;
}

function createEvent(evt){
  return mh().fromJSON({
      tag: 'tuentievent',
      attr: {
	  imageClass: "eventImg" + (evt.birth?" cumple":""),
	  url: evt.url,
	  nombre: evt.txt,
	  date: evt.cuando
      }
  })
  .flex(1)
  .bind("openurl",function(){
      if(evt.url)gotoURL(evt.url);
  })
  .bind("gcalendar",function(){
      var date = new Date(evt.time);
      var d = date.getDate() + "";
      var d2 = (date.getDate()+1) + "";
      var m = (date.getMonth()+1) + "";
      var h = date.getHours() + "";
      var h2 = (date.getHours()+1) + "";
      var i = date.getMinutes() + "";
      var url = "http://www.google.com/calendar/event?action=TEMPLATE";
      url += "&text=" + encodeURIComponent((evt.birth?"Cumpleaños de ":"") + evt.txt) + "&dates=";
      if(evt.allday){
	url += date.getFullYear() + "" + (m.length<2?"0"+m:m) + (d.length<2?"0"+d:d) + "/" +date.getFullYear() + "" + (m.length<2?"0"+m:m) + (d2.length<2?"0"+d2:d2);
      }else{
	url += date.getFullYear() + "" + (m.length<2?"0"+m:m) + (d.length<2?"0"+d:d) + "T" + (h.length<2?"0"+h:h) + (i.length<2?"0"+i:i) + "00/";
	url += date.getFullYear() + "" + (m.length<2?"0"+m:m) + (d.length<2?"0"+d:d) + "T" + (h2.length<2?"0"+h2:h2) + (i.length<2?"0"+i:i) + "00";
      }
      url += "&sprop=website:www.tuenti.com";
      gotoURL(url);
  })[0];
}
/*
 *Create a green link
 */
function createGreenLink(txt,url){
  return mh("<description>").appendtext(txt).addClass("actLink").click(function(){
      gotoURL(url);
  })[0];
}
/*
 *Create a green link with a icon
 */
function createGreenLinkIcon(txt,url,pos,tip){
  var a = document.createElement("description");
  var img = document.createElement("image");
  img.setAttribute("class","tuentiBtn");
  img.style.backgroundPosition = "-"+pos[0] + "px -" + pos[1] + "px";
  a.addEventListener("click",function(){followLink(a);},true);
  a.setAttribute("href",url);
  a.appendChild(wrapText(txt));
  a.appendChild(img);
  a.setAttribute("class","actLink");
  a.setAttribute("tooltiptext",tip);
  return a;
}
function createTextWithLinks(text){
    var url = /((http(s?))\:\/\/)([0-9a-zA-Z\-]+\.)+[a-zA-Z]{2,6}(\:[0-9]+)?(\/([\w#!:.?+=&%@~*\';,\-\/\$])*)?/m;
    var des = document.createElement("description");
    var txts = [];
    var urls = [];
    while(url.exec(text) != null){
	txts[txts.length] = RegExp.leftContext;
	urls[urls.length] = RegExp.lastMatch;
	text = RegExp.rightContext;
    }
    txts[txts.length] = text;
    
    des.appendChild(document.createTextNode(txts[0]));
    for(var i=0;i<urls.length;i++){
	var url = urls[i];
	var link = document.createElement("description");
	link.setAttribute("class","messagelink");
	link.setAttribute("href",urls[i]);
	var urltxt;
	if(url.length > 30){
	  urltxt = url.substring(0,14) + "…" + url.substring(url.length-14,url.length);
	}else{
	  urltxt = url;
	}
	link.appendChild(wrapText(urltxt));
	link.addEventListener("click",function(e){followLink(link);},true);
	des.appendChild(link);
	des.appendChild(document.createTextNode(txts[i+1]));
    }
    des.setAttribute("class", "MsgTxt");
    return des;
}
/*function createDescription(txt){
  var desc = document.createElement("description");
  desc.setAttribute("class", "MsgTxt");
  desc.appendChild(document.createTextNode(txt));
}*/
/**
 *Array with the images to remplace the text in your updates
 *format: {
      txt: A regexp to match
      icon: the url of the icon
      tip: A key from the strbundle (commons.properties).%1$S Will be remplaced by RegExp.$1 and %2$s will be remplaced be "s" if RegExp.$1 >1 and "" else
 }
 */
var update_images = [
  {
    txt: /([0-9]+ )mensajes? privados?/i,
    pos: [32,64],
    tip: "newmessage"
  },
  {
    txt: /([0-9]+ )petici[óo]ne?s? de amistad/i,
    pos: [32,48],
    tip: "newfriendrequest"
  },
  {
    txt: /([0-9]+ )invitaci[óo]ne?s? a ?u?n? eventos?/i,
    pos: [16,64],
    tip: "neweventinvite"
  },
  {
    txt: /([0-9]+ )fotos? donde sales/i,
    pos: [16,16],
    tip: "newphoto"
  },
  {
    txt: /([0-9]+ )comentarios? en (?:las )?fotos?/i,
    pos: [48,16],
    tip: "newphotocomment"
  },
  {
    txt: /([0-9]+ )mens\. de desconocidos/i,
    pos: [32,64],
    tip: "newunknownmessage"
  },
  {
    txt: /([a-z ]+)te ha aceptado/i,
    pos: [48,32],
    tip: "friendhaveaccepted"
  },
  {
    txt: /([0-9]+ )comentario[s]?/i,
    pos: [16,48],
    tip: "newcomments"
  },
  {
    txt: /([0-9]+ )etiquetas?/i,
    pos: [48,64],
    tip: "newtag"
  }
];
/**
 *Creates a 'update' link, with images
 */
function createUpdateLink(up,str){
    for each(var k in update_images){
      if(k.txt.test(up.txt)){
	return createGreenLinkIcon(RegExp.$1,up.url,k.pos,str.getFormattedString(k.tip,[RegExp.$1,(parseInt(RegExp.$1)>1)?"s":"",(parseInt(RegExp.$1)>1)?"es":""]));
      }
    }
    return createGreenLink(up.txt,up.url);
}

/**
 *Creates a button that links to the profile of the user with id == uid
 */
function createProfileButton(uid){
  
  /* Variable to handle the property file entities */
  var strbundle = Application.storage.get("TuentiStrbundle",null);
  
  var proBtn = document.createElement("btn");
  proBtn.setAttribute("class","tuentiBtn proBtn");
  proBtn.setAttribute("tooltiptext", strbundle.getString('viewprofile'));
  proBtn.addEventListener("click",function(event){
    gotoURL("http://www.tuenti.com/#m=Profile&func=index&user_id=" + uid);
    },true);
  return proBtn;
}


/**
 *Creates a button that opens the message tab to send a message to the user with id == uid
 */
function createMsgButton(uid){
  
  /* Variable to handle the property file entities */
  var strbundle = Application.storage.get("TuentiStrbundle",null);
  
  var sendmailBtn = document.createElement("btn");
  sendmailBtn.setAttribute("class","tuentiBtn mailBtn");
  sendmailBtn.setAttribute("tooltiptext", strbundle.getString('sendprivatemessage'));
  sendmailBtn.addEventListener("click",function(event){openMsgWindowById(uid);},true);
  return sendmailBtn;
}


/**
 *Creates a button that opens the message tab to send a message to the user with id == uid
 */
function createCommentButton(uid){
  
  /* Variable to handle the property file entities */
  var strbundle = Application.storage.get("TuentiStrbundle",null);
  
  var commentBtn = document.createElement("btn");
  commentBtn.setAttribute("class","tuentiBtn comBtn");
  commentBtn.setAttribute("tooltiptext", strbundle.getString('sendcomment'));
  commentBtn.addEventListener("click",function(event){openComWindowById(uid);},true);
  return commentBtn;
}

/**
 *Creates a user image 
 *url, class, tipid and tipurl arguments are ptional
 */
function createImage(src,url,clas,tipid,tipurl){
  var img = document.createElement("image");
  img.setAttribute("src", src);
  
  if(tipid){
    if(tipurl){
        var tooltip = document.createElement("tooltip");
	var imagetip = document.createElement("image");
	imagetip.setAttribute("src",tipurl);
	tooltip.appendChild(imagetip);
	tooltip.setAttribute("id",tipid);
	document.getElementById('tips').appendChild(tooltip);
    }
    img.setAttribute("tooltip",tipid);
  }
  
  if(clas)img.setAttribute("class",clas);
  
  if(url){
    img.setAttribute("href",url);
    img.addEventListener("click",function(event){followLink(img);},true);
  }
  return img;
}

function setReaded(e){
  if(e.target.parentNode.getAttribute("new") != "true")return;
  e.target.parentNode.setAttribute("new","false");
  TuentiProxy.readMsg(e.target.getAttribute("readURL"));
  var tmsg = document.getElementById("tab_privateMsg").firstChild;
  var msgt = tmsg.nodeValue;
  tmsg.nodeValue = msgt.substring(0,msgt.indexOf(" ")) + " (" + TuentiProxy.newMessages + ")";
}

function sendPrivateMsg(){
  var strbundle = Application.storage.get("TuentiStrbundle",null);
  var dst = document.getElementById("destinatario");
  var msg = document.getElementById("SMmensaje");
  
  var dt = msg.value;
  
  var f = TuentiProxy.getFriendByName(dst.value);
  if(!f || !f.id){
    alert(strbundle.getString("nombrenovalido"));
    return;
  }
  if(/^\s*$/.test(dt)){
    alert(strbundle.getString("camponovacio"));
    return;
  }
  
  var deck = document.getElementById("SendMPDeck");
  deck.setAttribute("selectedIndex","1");

  TuentiProxy.sendPrivateMessage(f.id, dt, function(success){
		deck.setAttribute("selectedIndex",success?"2":"3");
		window['setTimeout'](function(){
			deck.setAttribute("selectedIndex","0");
		},2000);
  });
  dst.value = "";
  msg.value = "";
}


function sendWallMsg(){
  var strbundle = Application.storage.get("TuentiStrbundle",null);
  var dst = document.getElementById("destinatarioP");
  var msg = document.getElementById("SPmensaje");
  
  var dt = msg.value;
  
  var f = TuentiProxy.getFriendByName(dst.value);
  if(!f || !f.id){
    alert(strbundle.getString("nombrenovalido"));
    return;
  }
  if(/^\s*$/.test(dt)){
    alert(strbundle.getString("camponovacio"));
    return;
  }
  
  var deck = document.getElementById("SendCMDeck");
  deck.setAttribute("selectedIndex","1");

  TuentiProxy.sendTablonMessage(f.id, dt,function(success){
		deck.setAttribute("selectedIndex",success?"2":"3");
		window['setTimeout'](function(){
			deck.setAttribute("selectedIndex","0");
		},2000);
  });
  dst.value = "";
  msg.value = "";
}

function profileById(id){
  gotoURL("http://www.tuenti.com/#m=Profile&func=index&user_id="+id);
}


function updateStatus() {
  var lbl = document.getElementById("mystatuslbl");
  lbl.value = TuentiProxy.getStatus();
}
var refreshListenerId = -1;
function main() {
    if (!TuentiProxy.isConnected()){
    var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIWebNavigation)
                   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                   .rootTreeItem
                   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIDOMWindow);
    
    mainWindow.toggleSidebar('viewtfxSidebar',true);   //close the sidebar (this is beaause sometimes firefox restarts and keeps the sidebar open, but it's not conected to tuenti)
    mainWindow.toggleSidebar('viewtfxSidebar');
    return;
  }

  
  setLoadingBoxVisible(true);
  updateData();
  
  var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  openLinksInNewTab = prefService.getBoolPref("extensions.tuentifox.datos.web.openlinksinnewtab");
  
  tuentiPrefObserver.register();
  
  refreshListenerId = TuentiProxy.addEventListener("refreshEnd",updateData);
  Application.storage.get("TuentiTimerStart",function(){})();  //start the timer
  
}
function onunload(){
  tuentiPrefObserver.unregister();
  TuentiProxy.removeEventListener(refreshListenerId);
  setLoadingBoxVisible(false);
}

function setLoadingBoxVisible(bool){
    var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
		 .getInterface(Components.interfaces.nsIWebNavigation)
		 .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
		 .rootTreeItem
		 .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
		 .getInterface(Components.interfaces.nsIDOMWindow);
    var lb = mainWindow.document.getElementById("TFox_loading_icon");
    if(lb)lb.setAttribute("collapsed",!bool);
}


function refresh(){
  TuentiProxy.refresh();
}
function inArray(arr,value) {
	for each(var k in arr) 
		if (k === value) 
			return true;
	return false;
}
const errbox = {
  "mensajes":"err_mensajes",
  "comentarios":"err_comentarios",
  "eventos":"err_eventos",
  "pictsContainer":"err_pictsContainer",
  "profile":"err_profile",
  "friends":"err_friends"
}
function setError(id,error){
  var id2 = errbox[id];
  if(!id2)return;
  document.getElementById(id).setAttribute("collapsed",error);
  document.getElementById(id2).setAttribute("collapsed",!error);
}

function updateData(){
  var strbundle = Application.storage.get("TuentiStrbundle",null);
  
  /*Amigos*/
  try{
      var list = document.getElementById("list");
      flushElm(list);
      flushElm(document.getElementById("tips"));
      for each(var friend in TuentiProxy.friends)
	if(friend.nick)list.appendChild(createUserElt(friend,strbundle));
      executeSearch();
      
      setError("friends",false);  
  }catch(e){
      dump(e);
      setError("friends",true);
  }
  
  /*mensajes*/
  /*try{
      var msgs = document.getElementById("mensajes");
      flushElm(msgs);
      var msgList = TuentiProxy.inbox;
      for (var i = 0; i < msgList.length; i++) {
	var msg = msgList[i];
	msgs.appendChild(createMsgElm(msg));
      }
      
      setError("mensajes",false);  
  }catch(e){
      dump(e);
      setError("mensajes",true);
  }*/

  /*imagenes */
  try{
      var picts = document.getElementById("pictsContainer");
      flushElm(picts);
      var picList = TuentiProxy.imagestag;
      for(var i=0;i<picList.length;i++){
	picts.appendChild(createImageElm(picList[i],strbundle));
      }
      
      setError("pictsContainer",false);  
  }catch(e){
      dump(e);
      setError("pictsContainer",true);
  }
  

  /*comentarios*/
  /*try{
      var coms = document.getElementById("comentarios");
      flushElm(coms);
      var comList = TuentiProxy.comments;
      for (var i = 0; i < comList.length; i++) {
	  coms.appendChild(createComElm(comList[i]));
      }
      
      setError("comentarios",false);  
  }catch(e){
      dump(e);
      setError("comentarios",true);
  }*/
  
  
  /*eventos*/
  try{
      var eHoy = document.getElementById("events_hoy_target");
      var eMan = document.getElementById("events_manana_target");
      var eSem = document.getElementById("events_semana_target");
      var ePro = document.getElementById("events_proximos_target");
      
      
      mh().add(eHoy,eMan,eSem,ePro).empty();
      
      function addToEvents(que,target){
	if(!que || !que.length){
	  target.appendChild(document.createTextNode(strbundle.getString("noevents")));
	  return;
	}
	for(var i = 0, l = que.length; i<l; i++){
	  target.appendChild(createEvent(que[i]));
	}
      }
      
      if(TuentiProxy.events){
	addToEvents(TuentiProxy.events.hoy,eHoy);
	addToEvents(TuentiProxy.events['mañana'],eMan);
	addToEvents(TuentiProxy.events.semana,eSem);
	addToEvents(TuentiProxy.events.proximos,ePro);
      }else{
	throw "...";
      }
      setError("eventos",false);  
  }catch(e){
      dump(e);
      setError("eventos",true);
  }
  
  /*caja de abajo*/
  try{
      var myupdates = document.getElementById("myupdates");
      flushElm(myupdates);
      var upList = TuentiProxy.updates;
      for(var i=0;i<upList.length;i++){
	      myupdates.appendChild(createUpdateLink(upList[i],strbundle));
      } 
    
      document.getElementById("myImage").setAttribute("src",TuentiProxy.myimg.func(30));
      document.getElementById("myImageBig").setAttribute("src",TuentiProxy.myimg.func(200));
      document.getElementById("myName").value = TuentiProxy.myname;
      setError("profile",false);  
  }catch(e){
      dump(e);
      setError("profile",true);
  }
  
  /*pestañas*/
  /*var tmsg = document.getElementById("tab_privateMsg");
  var msgt = tmsg.getAttribute("label");
  var tcom = document.getElementById("tab_comments");
  var comt = tcom.getAttribute("label");
  
  tmsg.setAttribute("label",
      (msgt.indexOf(" ")<=0?msgt:msgt.substring(0,msgt.indexOf(" "))) + " (" + TuentiProxy.getNewMsgCount() + ")"
  );
  tcom.setAttribute("label",
      (comt.indexOf(" ")<=0?comt:comt.substring(0,comt.indexOf(" "))) + " (" + TuentiProxy.getNewComCount() + ")"
  );*/
  

  makeUsersMenus();
  updateStatus();
}


function showStatusTextBox(){
  document.documentElement.addEventListener("click",hideStatusTextBox,true);
  //document.getElementById("deckstatus").setAttribute("selectedIndex",1);
  //document.getElementById("mystatuslbl").disabled = false;
  document.getElementById("updatebutton").collapsed = false;
  
}

function hideStatusTextBox(e){
  if(e && (e.target.id == "mystatuslbl" || e.target.id == "updatebutton"))
	return;
  document.getElementById("mystatuslbl").inputField.blur();
  document.documentElement.removeEventListener("click",hideStatusTextBox,true);
  //document.getElementById("mystatuslbl").;
  document.getElementById("updatebutton").collapsed = true;
}


function setStatus(e) {
  if(e && e.keyCode != 13)return;
  
  /* Variable to handle the property file entities */
  var strbundle = Application.storage.get("TuentiStrbundle",null);
  
  var tb = document.getElementById("mystatuslbl");
  var newstatus = tb.value;
  var button = document.getElementById("updatebutton");
  
  /* We disable the textbox and hide the button to show users
   * a visual feedback about the action*/
   
  button.setAttribute("hidden", "true");
  tb.setAttribute("disabled", "true");
  tb.value = strbundle.getString("refreshstatus");
  
  TuentiProxy.setStatus(newstatus, function(success){
	tb.value= strbundle.getString(success?'statusupdated':'statuserror');
	window['setTimeout'](function(){
	  	button.setAttribute("hidden", "false");
	  	tb.removeAttribute("disabled");
	  	tb.value = newstatus;
		hideStatusTextBox();
  	}, 2000);  
	
  });
}

var tabs = {
'tab_friends':'listc',
//'tab_privateMsg':'pmsg',
'tab_pictures':'picts',
//'tab_comments':'comments',
'tab_events' : 'events'
};

function switchTab(tab){
  /*for(var k in tabs)
	document.getElementById(tabs[k]).setAttribute("collapsed","true");
  document.getElementById(tabs[tab]).setAttribute("collapsed","false");*/
  document.getElementById("tuentiTabBox").selectedTab = document.getElementById(tab);
}

function showUploadImagesDialog(){
  window.openDialog("chrome://tuenti/content/tuentiImages.xul","Upload",'resizable=no');
}

function followLink(elm){
  gotoURL(elm.getAttribute("href"));
}

function gotoURL(url){
  var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
  var uri = ios.newURI(url, null, null);
  
  if(openLinksInNewTab){
    var newTab = Application.activeWindow.open(uri);
    newTab.focus();
  }else{
    Application.activeWindow.activeTab.load(uri);
  }
}
function showAllImages(){
  gotoURL("http://www.tuenti.com/#m=fotos&view=category&collection_key=1-" + TuentiProxy.myuid);
}
function openMsgWindowById(user){
  if(user)
    openMsgWindow(TuentiProxy.getFriendById(user).nick);
}
function openMsgWindow(user){
  switchTab("tab_privateMsg");
  if(user != undefined){
    document.getElementById("destinatario").value = user;
    document.getElementById("destinatario").setAttribute("idef","false");
    document.getElementById("SMmensaje").focus();
  }
}
function openComWindowById(user){
  if(user != undefined){
    openComWindow(TuentiProxy.getFriendById(user).nick);
  }
}
function openComWindow(user){
  /*switchTab("tab_comments");
  if(user != undefined){
    document.getElementById("destinatarioP").value = user;
    document.getElementById("destinatarioP").setAttribute("idef","false");
    document.getElementById("SPmensaje").focus();
  }*/
}
function flushElm(elm){
    while(elm.hasChildNodes()){
      elm.removeChild(elm.firstChild);
    }
}

function makeUsersMenus(){
  var users = getUsers();
  var um = document.getElementById("userspop");
  var strbundle = Application.storage.get("TuentiStrbundle",null);
  flushElm(um);
  
  for(var i=0;i<users.length;i++){
    var item = document.createElement("menuitem");
    item.setAttribute("type","radio");
    item.setAttribute("label",users[i]);
    if(TuentiProxy.myemail == users[i]){
      item.setAttribute("checked","true");
    }else{
      item.setAttribute("oncommand","changeUser(this)");
    }
    um.appendChild(item);
  }
  um.appendChild(document.createElement("menuseparator"));
  var item = document.createElement("menuitem");
  item.setAttribute("label",strbundle.getString("new"));
  item.setAttribute("oncommand","changeUser('--TuentiForceNewUser')");
  um.appendChild(item);
  um.appendChild(document.createElement("menuseparator"));
  var item = document.createElement("menuitem");
  item.setAttribute("label",strbundle.getString("logout"));
  item.setAttribute("oncommand","changeUser('--TuentiLogOut')");
  um.appendChild(item);
}

function changeUser(elm){
  var fun =Application.storage.get("TuentiReconectFnc",null);
  if(!fun)return;
  if(elm === "--TuentiForceNewUser"){
      fun(null,null,true);
  }else if(elm === "--TuentiLogOut"){
      fun(null,null,false,true);
  }else{
      if(fun)fun(elm.getAttribute("label"));
  }
}

function getUsers(){
        var hostname = 'chrome://tuenti';
        var formSubmitURL = 'User - Pass';
        var httprealm = null;
        try {
           // Get Login Manager 
           var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
           // Find users for the given parameters
           var logins = myLoginManager.findLogins({}, hostname, formSubmitURL, httprealm);
              
           // Find user from returned array of nsILoginInfo objects
	   
	   var users=[];
           for (var i = 0; i < logins.length; i++) {
		users.push(logins[i].username);
           }
        }
        catch(ex) {
           // This will only happen if there is no nsILoginManager component class
        }
	return users;
}

var accents         = ['á','é','í','ó','ú','ü','ö'];
var no_accents      = ['a','e','i','o','u','u','o'];
function stripAccents(text){
        text = text.toLowerCase().replace(/^\s*/,'').replace(/\s*$/,'');
        for (var letter in accents){
                text = text.replace(new RegExp(accents[letter],"ig"),no_accents[letter]);
        }
        return " " + text.replace(/[^a-zñ ]/gm,'');
}
function updateSearch(val){
  searchQuery = val;
  executeSearch();
}
function executeSearch(){
  var qs = stripAccents(searchQuery);
  var elms = document.getElementById("list");
  var showAll = /^\s*$/.test(qs);
  for each(var k in elms.childNodes){
      if(!k || k.tagName != "tuentifriend")continue;
      if(showAll)
	    k.setAttribute("collapsed","false");
      else{
	  var name = stripAccents(k.getAttribute("tuentiname"));
	  if(name.indexOf(qs) >= 0)
	    k.setAttribute("collapsed","false");
	  else
	    k.setAttribute("collapsed","true");
      }
  }
}



window.addEventListener("load", main, true);
window.addEventListener("unload", onunload, true);


window.addEventListener("tuentimsg",function(e){
    openMsgWindowById(e.friend);
},false);

window.addEventListener("tuentiwall",function(e){
    openComWindowById(e.friend);
},false);

window.addEventListener("tuentiprofile",function(e){
    profileById(e.friend);
},false);

window.addEventListener("tuentigroup",function(e){
    window.openDialog("chrome://tuenti/content/tuentiGroups.xul","Grupos","chrome,modal,centerscreen",{id:e.friend});
},false);