 var EXPORTED_SYMBOLS = ["CookieMonster","Scheduler"]  //Note: this simbols will not be added to the global scope
 /*  
  *Cookie Monster. Original code is from Michael G. Noll
  *http://www.michael-noll.com/wiki/Cookie_Monster_for_XMLHttpRequest
  */
 
 /*
  *MODIFICADO para poder editar las cookies en vez de eliminarlas
  */ 
  
/*COOKIE MONSTER
 *Copyright (c) 2006 Michael G. Noll <http://www.michael-noll.com/>
    Documentation:
    http://www.michael-noll.com/wiki/Cookie_Monster_for_XMLHttpRequest
    Original article:
    http://www.michael-noll.com/blog/2006/06/16/the-cookie-monster-or-how-to-remove-cookies-from-xmlhttprequest/
 */
//Modificado para poder editar las cookies en vez de eliminarlas
function CookieMonster(aXMLHttpRequest,add,galleta){
    this.channel_ = aXMLHttpRequest.channel;
    this.galleta = galleta;
    this.add = add;
    this.topic_ = "http-on-modify-request";// happens after the cookie data has been loaded into the request,but before the request is sent
    this.observerService_ = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    this.observerService_.addObserver(this, this.topic_, false /* hold a strong reference */);
    this.lunchTime_ = new Scheduler(this.stopEating, 15000 /* stop eating after 15 seconds */);     // we want to have a defined end time for removing the observer again we assume that waiting 15 seconds for cookies is enough in practice;
}

/*
    Be a standard conform cookie monster.
*/
CookieMonster.prototype.QueryInterface = function(iid){
    if (iid.equals(Components.interfaces.nsISupports)||iid.equals(Components.interfaces.nsIObserver))
        return this;
    throw Components.results.NS_ERROR_NO_INTERFACE;
}

/*
    When we are notified that a cookie comes our way through our channel
    (attached to the XMLHttpRequest), we will eat all of them, i.e. remove them.
*/
CookieMonster.prototype.observe = function(subject, topic, data){
    if (topic != this.topic_ || subject != this.channel_)
        return; // not our cookies, bleh (as if the original cookie monster did care...)
    this.channel_.QueryInterface(Components.interfaces.nsIHttpChannel);// lunch time!
    this.channel_.setRequestHeader("Cookie", this.galleta + (this.add?"; " +this.channel_.getRequestHeader("Cookie"):""), false); // aaah, cookies! scrunch, scrunch...
    this.lunchTime_.stop(); // Cookies will only be included once to the HTTP channel, so whenever we have been notified via topic "http-on-modify-request" and ate all cookies, our work is done and we will stop eating.
    this.stopEating();
}

/*
    Stop eating cookies.
*/
CookieMonster.prototype.stopEating = function(){
    if(this.observerService_)this.observerService_.removeObserver(this, this.topic_); // avoid memory leaks // we finished our lunch, so we clean up (again, as if the original cookie monster...)
    delete(this.channel_);
    delete(this.lunchTime_);
    delete(this.observerService_);
}

/*
    A scheduler for executing a function (callback) after a specified amount of time.

    First parameter:    function variable, executing on every beat
    Second parameter:   time (in ms) after which the supplied function is called
*/
function Scheduler(callback, callAfter_MS){
    this.callback_ = callback;
    this.timer_ = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);// get a timer
    var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);// we want to stop the beat on shutdown
    observerService.addObserver(this, "xpcom-shutdown", false);
    this.timer_.initWithCallback(this, callAfter_MS, this.timer_.TYPE_ONE_SHOT);// initialize the timer to fire after the given ms interval
}

Scheduler.prototype.QueryInterface = function(iid){
    if (iid.equals(Components.interfaces.nsISupports) || iid.equals(Components.interfaces.nsITimerCallback) || iid.equals(Components.interfaces.nsIObserver))
        return this;
    throw Components.results.NS_ERROR_NO_INTERFACE;
}

Scheduler.prototype.observe = function(aSubject, aTopic, aData){
    if (aTopic == "xpcom-shutdown")// stop the beat on shutdown (see http://wiki.mozilla.org/XPCOM_Shutdown)
        this.stop();
}

Scheduler.prototype.stop = function(){
    if (this.timer_) {
        this.timer_.cancel();// stop the timebeat and remove the observer
        this.timer_ = null;
        this.callback_ = null;
        var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
        observerService.removeObserver(this, "xpcom-shutdown");
    }
}

Scheduler.prototype.notify = function(aTimer){
    this.callback_();
    this.stop();
}